<?php


class wps_no_run {


  public function __construct() {
    add_action('wps_no_worker', array($this, 'check_time'));

    if (!empty($_GET['night_owl'])) {
      $this->check_time();
    }
  }


  public function check_time() {
    $settings = get_option(WPS_IC_SETTINGS);

    if (empty($settings['wps_no']['time']) || $settings['wps_no']['time'] == '0') {
      return false;
    }

    // Get time from database
    $time = $settings['wps_no']['time']; // 1:00 PM OR 6:00 AM or...

    // Explode 0 => time, 1 => suffix PM/AM
    $time   = explode(' ', $time);
    $suffix = $time[1];
    $time   = $time[0];

    // Today Date
    $date = date('d-m-Y');



    if ($suffix == 'AM') {
      // We need to take a look at previous day also.
      $date = date('d-m-Y', time() - 60*60*24);

    } else {
      $date = date('d-m-Y');
    }

    $compiled_time = $date . ' ' . $time . ' ' . $suffix;

    $last_trigger = get_option('wps_no_last_trigger');

    // if (time() >= strtotime($date . ' 12:30 PM')) { ==> WORKS
    if (current_time('timestamp') >= strtotime($date . ' ' . $time . ' ' . $suffix)) {

      $current_time = current_time('timestamp'); // 19.10.2017 10:48 AM
      // $last_trigger => 19.10.2017 09:48

      $next_trigger = current_time('timestamp');
      if (!empty($last_trigger)) {
        $next_trigger = $last_trigger+60*60*24;
      }



      if (date('h:i A', current_time('timestamp')) == $time . ' ' . $suffix || $next_trigger <= current_time('timestamp')) {
        $this->trigger();
        $msg = '';
        $msg .= print_r(current_time('timestamp'), true) . "\r\n";
        $msg .= print_r($last_trigger, true) . "\r\n";
        $msg .= print_r(strtotime($date . ' ' . $time . ' ' . $suffix), true) . "\r\n";
        mail('hrvoje.krbavac@gmail.com', 'Night Owl Triggered', $msg);
      } else {
        #var_dump('Next run at ' . date('H:i', $last_trigger));
        mail('hrvoje.krbavac@gmail.com', 'Night Owl Timer Active', 'Timer still active');
        wp_send_json_success('Not time yet. ' . date('h:i A', current_time('timestamp')) . ' != ' . $time. ' ' . $suffix);
      }

      #echo 'Proslo je ' . date('d-m-Y H:i', time()) . ' a trazim ' . date('d-m-Y H:i', strtotime($date . ' 09:39 AM'));
    } else {
      mail('hrvoje.krbavac@gmail.com', 'Night Owl Time not yet', 'Time not yet');
      wp_send_json_success('Failed Current time: ' . date('d.m.Y H:i', current_time('timestamp')) . ' Run at: ' . $date . ' ' . $time . ' ' . $suffix);
      #echo 'Jos nije proslo. ' . date('d-m-Y H:i', time()) . ' a trazim ' . date('d-m-Y H:i', strtotime($date . ' 09:39 AM'));
    }

  }


  public function trigger() {
    global $wpdb;
    $wps_ic = new wps_ic();

    // Allowed Types
    $allowed_types         = array();
    $allowed_types['jpg']  = 'jpg';
    $allowed_types['jpeg'] = 'jpeg';
    $allowed_types['gif']  = 'gif';
    $allowed_types['png']  = 'png';

    $settings     = get_option(WPS_IC_SETTINGS);
    $last_trigger = get_option('wps_no_last_trigger');
    #$last_attachment_ID = get_option('wps_no_last_attachment_ID');
    $last_attachment_ID = 0;

    $ignore_attachments_before = date('d.m.Y', $settings['wps_no']['date']-60*60*24);


    $processed = $wpdb->get_results('SELECT attachment_ID FROM ' . $wpdb->prefix . 'ic_compressed');
    $processed_list = array();
    if ($processed) {
      foreach ($processed as $item) {
        $processed_list[] = $item->attachment_ID;
      }
    }

    $attachments = get_posts(array('post_type' => 'attachment', 'posts_per_page' => - 1,'date_query' => array(
      array(
        'after'     => $ignore_attachments_before,
        'inclusive' => true,
      ),
    ), 'post__not_in' => $processed_list));


    if ( $attachments ) {
      foreach ($attachments as $attachment) {
        #$src = wp_get_attachment_image_src($attachment->ID, 'full');
        #echo '<img src="' . $src[0] . '" style="width:100px;"/>';

        // Excluded
        $excluded = get_post_meta($attachment->ID, 'wps_ic_exclude', true);
        if ( ! empty($excluded)) {
          continue;
        }

        // Allowed Type
        $file_data = get_attached_file($attachment->ID);
        $type      = wp_check_filetype($file_data);

        if ( ! in_array($type['ext'], $allowed_types)) {
          continue;
        }

        // Already Compressed
        $data = get_post_meta($attachment->ID, 'wps_ic_data', true);
        if ( ! empty($data) && !empty($data['new']) && $data['new']['size'] != '') {
          continue;
        }

        // All OK? Compress!
        $src = wp_get_attachment_image_src($attachment->ID, 'full');
        if (!empty($src[0]) && $attachment->ID > $last_attachment_ID) {
          $wps_ic->compress->single_bulk(array('attachment_id' => $attachment->ID), 'none');
          update_option('wps_no_last_attachment_ID', $attachment->ID);
        }

      }

      // TODO: add mail after it's done

    } else {
      // TODO: add mail after it's done

    }

    update_option('wps_no_last_trigger', time());
  }


}