<?php
define('WPS_NO', 'wps_no');
define('WPS_NO_URI', plugin_dir_url(__FILE__));
define('WPS_NO_DIR', plugin_dir_path(__FILE__));

include 'classes/main.class.php';
include 'classes/enqueue.class.php';
include 'classes/run.class.php';

class wps_no {

  /**
   * Our main class constructor
   */
  public function __construct() {
    global $wps_no;

    $this->main = new wps_no_main();
    $this->enqueue = new wps_no_enqueue();
    $this->run = new wps_no_run();

    if (!get_option('wps_no_next_trigger')) {
      update_option('wps_no_next_trigger', time());
    }
  }


  public static function init() {
    $class = __CLASS__;
    new $class;
  }


  /**
   * Activation of the plugin
   */
  public static function activation() {
    // Setup bulk cron
    if ( ! wp_next_scheduled('wps_no_worker')) {
      wp_schedule_event(time(), 'hourly', 'wps_no_worker');
    }
  }


  /**
   * Deactivation of the plugin
   */
  public static function deactivation() {
    wp_unschedule_event(time(), 'wps_no_worker');
  }

}

/*
add_action('init', array('wps_no', 'init'));
register_activation_hook(__FILE__, array('wps_no', 'activation'));
register_deactivation_hook(__FILE__, array('wps_no', 'deactivation'));
*/