jQuery(document).ready(function ($) {


    setInterval(function() {
        if (wps_bulk_running == false) {
            wps_ic_bulk_heartbeat();
        }
    }, 4500);


    /**
     * Single Compress Heartbeat
     */
    function wps_ic_compress_heartbeat() {
        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_compress_background_cron'}, function (response) {
            if (response.success == true) {

                $.each(response.data, function (attachment_id, value) {

                    trigger_speed = 5000;

                    if (response.data == 'excluded') {

                        // Hide Loading
                        $('#wp-ic-image-actions-' + attachment_id).show();
                        $('#wp-ic-image-loading-' + attachment_id).hide();

                    } else if (response.data == 'not_enough_credits') {

                        // Hide Loading
                        $('#wp-ic-image-actions-' + attachment_id).show();
                        $('#wp-ic-image-loading-' + attachment_id).hide();

                    } else {
                        if (response.success) {
                            // Output Image info
                            $('div#wp-ic-image-' + attachment_id).html(value.output);

                            // Setup new actions
                            $('div#wp-ic-image-actions-' + attachment_id).html(value.actions);

                            // Update restore button path
                            //$('input[name="wps_ic_restore_' + attachment_id + '"]').val(response.data.restore_path);

                            // Hide Loading
                            $('#wp-ic-image-actions-' + attachment_id).show();

                            $('#wp-ic-image-loading-' + attachment_id).hide();
                        }
                    }
                });
            }

            setTimeout(function () {
                wps_ic_compress_heartbeat();
            }, trigger_speed);

            //wps_ic_bulk_heartbeat();

        });
    }

    wps_ic_compress_heartbeat();


    /**
     * Waterfall dialog popup
     */
    $('.wps-ic-time-explain').live('click', function (e) {
        e.preventDefault();

        var li = $(this).parent();
        var html = $('.wps-ic-time-explain-box', li).html();


        swal({
            title: '<strong>Compression Waterfall</strong>',
            html: html,
            showCloseButton: true,
            showCancelButton: false,
            showConfirmButton: false,
        });

        return false;
    });


});

/**
 * Bulk Actions Heartbeat
 */
function wps_ic_bulk_heartbeat() {


    var time = 0;

    if (wps_bulk_running) {
        return false;
    }

    wps_bulk_running = true;

    jQuery.post(ajaxurl, {action: 'wps_ic_bulk_heartbeat'}, function (response) {

        if (response.success == false) {
            wps_bulk_running = false;
        }

        if (typeof response.data.restore_queue !== 'undefined') {
            if (response.data.restore_queue != '') {

                jQuery.each(response.data.restore_queue, function (attachment_id, value) {
                    time++;
                    setTimeout(function() {
                        jQuery.ajaxSetup({async: true, cache: false});
                        jQuery.post(ajaxurl, {action: 'wps_ic_restore_attachment', attachment_id: attachment_id}, function (response) {


                            if (response.data == 'excluded') {

                                // Hide Loading
                                $('#wp-ic-image-actions-' + attachment_id).show();
                                $('#wp-ic-image-loading-' + attachment_id).hide();

                            } else if (response.data == 'not_enough_credits') {

                                // Hide Loading
                                $('#wp-ic-image-actions-' + attachment_id).show();
                                $('#wp-ic-image-loading-' + attachment_id).hide();

                            } else {
                                wps_bulk_running = false;

                                if (response.success) {

                                    wps_restore_objects.splice(jQuery.inArray(attachment_id, wps_restore_objects),1);

                                    setTimeout(function(){
                                        // Rerun bulk
                                        wps_ic_bulk_heartbeat();
                                    }, 500);

                                    // Output Image info
                                    if (typeof response.data.info !== 'undefined') {
                                        jQuery('div#wp-ic-image-' + attachment_id).html(response.data.info);
                                    }

                                    // Setup new actions
                                    jQuery('div#wp-ic-image-actions-' + attachment_id).html(response.data.actions);

                                    // Update restore button path
                                    jQuery('input[name="wps_ic_restore_' + attachment_id + '"]').val(response.data.restore_path);

                                    // Hide Loading
                                    jQuery('#wp-ic-image-actions-' + attachment_id).show();

                                    jQuery('#wp-ic-image-loading-' + attachment_id).hide();
                                }
                            }
                        });
                    }, 550*time);

                    return false;

                });
            }
        }


        if (typeof response.data.compress_queue !== 'undefined') {
            if (response.data.compress_queue != '') {
                jQuery.each(response.data.compress_queue, function (attachment_id, value) {

                        jQuery.ajaxSetup({async: true, cache: false});
                        jQuery.post(ajaxurl, {action: 'wps_ic_compress', attachment_id: attachment_id}, function (response) {

                            if (response.data == 'no_credits') {
                                //alert('Your account has been disabled due to Exceeded Quota Limits!');

                                swal({
                                    title: '',
                                    html: jQuery('#ic_no_credits_popup').html(),
                                    showCloseButton: true,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                    onClose:function(){
                                        window.location.reload();
                                    }
                                });

                                wps_ic_bulk_running = false;


                                return false;
                            }


                            if (response.data == 'blocked') {
                                //alert('Your account has been disabled due to Exceeded Quota Limits!');

                                swal({
                                    title: '',
                                    html: jQuery('#ic_blocked_popup').html(),
                                    showCloseButton: true,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                    onClose:function(){
                                        window.location.reload();
                                    }
                                });

                                wps_ic_bulk_running = false;


                                return false;
                            }

                            if (response.data == 'excluded') {

                                // Hide Loading
                                jQuery('#wp-ic-image-actions-' + attachment_id).show();
                                jQuery('#wp-ic-image-loading-' + attachment_id).hide();

                            } else if (response.data == 'not_enough_credits') {

                                // Hide Loading
                                jQuery('#wp-ic-image-actions-' + attachment_id).show();
                                jQuery('#wp-ic-image-loading-' + attachment_id).hide();

                                // No Credits Popup
                                swal({
                                    title: '',
                                    html: jQuery('#ic_no_credits_popup').html(),
                                    showCloseButton: true,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                    onClose:function(){
                                        window.location.reload();
                                    }
                                });

                            } else {
                                wps_bulk_running = false;

                                if (response.success) {

                                    setTimeout(function(){
                                    // Rerun bulk
                                    wps_ic_bulk_heartbeat();
                                    }, 500);

                                    wps_compress_objects.splice(jQuery.inArray(attachment_id, wps_compress_objects),1);


                                    // Output Image info
                                    jQuery('div#wp-ic-image-' + attachment_id).html(response.data.info);

                                    // Setup new actions
                                    jQuery('div#wp-ic-image-actions-' + attachment_id).html(response.data.actions);

                                    // Update restore button path
                                    jQuery('input[name="wps_ic_restore_' + attachment_id + '"]').val(response.data.restore_path);

                                    // Hide Loading
                                    jQuery('#wp-ic-image-actions-' + attachment_id).show();

                                    jQuery('#wp-ic-image-loading-' + attachment_id).hide();
                                } else {
                                    //alert(response.data);
                                    //wps_ic_fixing();
                                }
                            }
                        });


                    return false;

                });
            }
        }

    });

    //wps_ic_heartbeat(5);
}


/**
 * Remote Restore Heartbeat
 */
function wps_ic_remote_restore_heartbeat() {

    wps_bulk_running = true;
    var time = 0;

    jQuery.post(ajaxurl, {action: 'wps_ic_bulk_heartbeat'}, function (response) {

        if (response.success == false) {
            wps_bulk_running = false;
        }

        if (typeof response.data.restore_queue !== 'undefined') {
            if (response.data.restore_queue != '') {

                jQuery.each(response.data.restore_queue, function (attachment_id, value) {
                    time++;
                    setTimeout(function() {
                        jQuery.ajaxSetup({async: true, cache: false});
                        jQuery.post(ajaxurl, {action: 'wps_ic_remote_restore', attachment_id: attachment_id}, function (response) {
                            if (response.data == 'excluded') {

                                // Hide Loading
                                $('#wp-ic-image-actions-' + attachment_id).show();
                                $('#wp-ic-image-loading-' + attachment_id).hide();

                            } else if (response.data == 'not_enough_credits') {

                                // Hide Loading
                                $('#wp-ic-image-actions-' + attachment_id).show();
                                $('#wp-ic-image-loading-' + attachment_id).hide();

                            } else {
                                if (response.success) {

                                    wps_restore_objects.splice(jQuery.inArray(attachment_id, wps_restore_objects),1);

                                    // Rerun bulk
                                    wps_ic_remote_restore_heartbeat();

                                    // Output Image info
                                    if (typeof response.data.info !== 'undefined') {
                                        jQuery('div#wp-ic-image-' + attachment_id).html(response.data.info);
                                    }

                                    // Setup new actions
                                    jQuery('div#wp-ic-image-actions-' + attachment_id).html(response.data.actions);

                                    // Update restore button path
                                    jQuery('input[name="wps_ic_restore_' + attachment_id + '"]').val(response.data.restore_path);

                                    // Hide Loading
                                    jQuery('#wp-ic-image-actions-' + attachment_id).show();

                                    jQuery('#wp-ic-image-loading-' + attachment_id).hide();
                                } else {
                                    alert(response.data);
                                }
                            }
                        });
                    }, 250*time);

                    return false;

                });
            }
        }


    });

    //wps_ic_heartbeat(5);
}