jQuery(document).ready(function ($) {

    /**
     * Hide After
     */
    $('.wps-ic-hide').each(function(i, item){
       var after = $(item).data('after');
       setTimeout(function(){
           $(item).fadeOut(500);
       }, after*1000);
    });

    /**
     * Signup Form
     */
    $('form#wps_ic_signup_form').submit(function (e) {
        e.preventDefault();

        var error = false;
        var form = $(this);
        var inner = $('.wps_ic_singup_form', form);
        var loading = $('.wps-ic-form-loading-container');

        var email = $('input[name="email"]', form).val();
        var name = $('input[name="name"]', form).val();

        if (email == '') {
            $('input[name="email"]', form).addClass('ic_required');
            error = true;
        }

        if (name == '') {
            $('input[name="name"]', form).addClass('ic_required');
            error = true;
        }

        if (error == false) {

            $(form).hide(function () {
                $(loading).show();

                $.post(ajaxurl, {action: 'wps_ic_api_signup', email: email, name: name}, function (response) {
                    if (response.success) {

                        var success = $('.wps-ic-form-success-container');
                        var msg = $('.wps-ic-form-subscribe');
                        var error = $('.wps-ic-form-error');

                        $(loading).hide();

                        /*
                        $(success).show();
                        $(msg).show();
                        */

                        swal({
                            title: '',
                            text: 'Please check your email to \n' + 'obtain your API Key',
                            imageUrl: 'https://www.wpcompress.com/icon_success.png',
                            imageWidth: 180,
                            imageHeight: 180,
                            imageAlt: 'Custom image',
                            showConfirmButton:false,
                            showCloseButton:true
                        }).then(function (dismiss) {
                        });

                        setTimeout(function(){
                        window.location.href = window.location.href + '&do=have_api_key';
                        }, 1000);
                        //$(form).show();

                    } else {

                        var success = $('.wps-ic-form-success-container');
                        var error = $('.wps-ic-form-error');
                        var error_msg = 'An error occured!';

                        if (response.data.code == 100) {
                            error_msg = response.data.msg;
                        } else {
                            error_msg = response.data.msg;
                        }

                        $(loading).hide();

                        swal({
                            title: '',
                            html: error_msg,
                            imageUrl: 'https://www.wpcompress.com/icon_error.png',
                            imageWidth: 180,
                            imageHeight: 180,
                            imageAlt: 'Custom image',
                            showConfirmButton:false,
                            showCloseButton:true
                        }).then(function (dismiss) {
                        });

                        //window.location.href = window.location.href + '&do=have_api_key';
                        $(form).show();


                        /*
                        $(success).show();
                        $(error).show();
                        */
/*
                        setTimeout(function(){
                            $(success).hide();
                            $(error).hide();
                            $(form).show();
                        },5000);*/
                    }
                });
            });


        }

        return false;
    });


    /**
     * Activate Form
     */
    $('form#wps_ic_activate_form').submit(function (e) {
        e.preventDefault();

        var error = false;
        var form = $(this);
        var inner = $('.wps_ic_activate_form', form);
        var loading = $('.wps-ic-form-loading-container');

        var apikey = $('input[name="apikey"]', form).val();

        if (apikey == '') {
            $('input[name="apikey"]', form).addClass('ic_required');
            error = true;
        }

        if (error == false) {

            $(form).hide(function () {
                $(loading).show();

                $.post(ajaxurl, {action: 'wps_ic_api_connect', apikey: apikey}, function (response) {
                    if (response.success == true) {
                        $(form).hide();

                        var success = $('.wps-ic-form-success-container');
                        var msg = $('.wps-ic-form-connect');

                        $(loading).hide();

                        swal({
                            title: '',
                            text: 'You have successfully connected to the Compression Cloud!',
                            imageUrl: 'https://www.wpcompress.com/icon_success.png',
                            imageWidth: 180,
                            imageHeight: 180,
                            imageAlt: 'Custom image',
                            showConfirmButton:false,
                            showCloseButton:true
                        }).then(function (dismiss) {
                            window.location.reload();
                        });

                        setTimeout(function(){
                            window.location.reload();
                        }, 2000);

                    } else {

                        var success = $('.wps-ic-form-success-container');
                        var error = $('.wps-ic-form-error');


                        $(loading).hide();

                        swal({
                            title: '',
                            text: response.data.msg,
                            imageUrl: 'https://www.wpcompress.com/icon_error.png',
                            imageWidth: 180,
                            imageHeight: 180,
                            imageAlt: 'Custom image',
                            showConfirmButton:false,
                            showCloseButton:true
                        }).then(function (dismiss) {
                        });

                        $(form).show();
                    }
                });
            });

        }

        return false;
    });


    /**
     * Signup Start
     */
    $('.wps-ic-signup').submit(function (e) {
        e.preventDefault();

        var form = $(this);
        var button = $('input[name="submit"]', form);
        var input = $('input[type="text"]', form);
        var email = $('input[name="email"]', form).val();
        var name = $('input[name="name"]', form).val();
        var error = false;

        if (email == '') {
            $('input[name="email"]', form).addClass('ic_required');
            error = true;
        }

        if (name == '') {
            $('input[name="name"]', form).addClass('ic_required');
            error = true;
        }

        if (error == false) {
            var apiform = $('form.wps-ic-api');
            var apimail = $('input[name="apimail"]', apiform);

            $(input).attr('disabled', 'disabled');
            $(button).hide();
            $('#wps-ic-signup-loading').show();

            $.post(ajaxurl, {action: 'wps_ic_api_signup', email: email, name: name}, function (response) {
                if (response.success == false) {
                    $(form).hide();
                    $('#wps-ic-signup-loaded').show().html(response.data);
                } else {
                    alert(response.data);
                }
            });
        }

        return false;
    });


    /**
     * Connect to API
     */
    $('.wps-ic-api').submit(function (e) {
        e.preventDefault();

        var form = $(this);
        var button = $('input[name="submit"]', form);
        var apikey = $('input[name="apikey"]', form).val();

        $(button).hide();
        $('#wps-ic-api-loading').show();

        $.post(ajaxurl, {action: 'wps_ic_api_connect', apikey: apikey}, function (response) {
            if (response.success) {
                $(form).hide();
                $('#wps-ic-api-loaded').show();
                window.location.reload();
            } else {
                if (response.data == 0) {
                    alert('Unkown error occured!');
                } else if (response.data == 400) {
                    alert('You\'r email is not confirmed!');
                } else if (response.data == 500) {
                    alert('You have not subscribed!');
                }
            }
        });

        return false;
    });


    if ($('.wps-ic-trigger_connect').length) {
        var link = $('.wps-ic-authorize-api').attr('href');
        $.ajaxSetup({async: false, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_authorize_api'}, function (response) {
            if (response.success) {
                window.location.href = link;
            } else {
                alert(response.data);
            }
        });
    }

    /**
     * Authorize with remote API
     */
    $('.wps-ic-authorize-api').on('click', function (e) {

        $.ajaxSetup({async: false, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_authorize_api'}, function (response) {
            if (response.success) {
                window.location.reload();
            } else {
                alert(response.data);
            }
        });

    });


    /**
     * Deauthorize with remote API
     */
    $('.wps-ic-deauthorize-api').on('click', function (e) {

        $.ajaxSetup({async: false, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_deauthorize_api'}, function (response) {
            if (response.success) {
                window.location.reload();
            } else {
                alert(response.data);
            }
        });

    });

    $('.checkbox-label').on('click', function (e) {
        e.preventDefault();
        var For = $(this).attr('for');
        $('#' + For).trigger('click');
    });

    /**
     * Change Optimization
     */
    $('.wps-ic-change-optimization').on('click', function (e) {
        e.preventDefault();

        var link = $(this);
        var value = $(link).data('optimization_level');

        $('input#wp-ic-setting-optimization').attr('value', value);

        $.post(ajaxurl, {action: 'wps_ic_settings_change', what: 'optimization', value: value}, function (response) {
            if (response.success) {
                // Nothing
            } else {
                alert('Oops! We weren\'t able to save your settings! :(');
            }
        });
    });


    /**
     * Change Setting
     */
    $('.wps-ic-change-setting').on('click', function (e) {

        var input = $(this);
        var setting = $(input).data('setting_name');
        var value = $(input).data('setting_value');

        if ($(input).is(':checkbox')) {
            if ($(input).is(':checked')) {
                var value = '1';
                $(input).addClass('active');
                $(input).attr('checked', 'checked');
            } else {
                var value = '0';
                $(input).removeClass('active');
                $(input).removeAttr('checked');
            }
        }

        $.post(ajaxurl, {action: 'wps_ic_settings_change', what: setting, value: value}, function (response) {
            if (response.success) {
                // Nothing
            } else {
                alert('Oops! We weren\'t able to save your settings! :(');
            }
        });

    });

});