<?php


/**
 * Class - Cron
 */
class wps_ic_cron {
	
	public function __construct() {
    $this->api_url = 'http://devapi.wpcompress.com/';
		add_action('wps_ic_single_thumbnail', array($this, 'cron_regenerate_single_thumbnail'), 10, 1);

		add_action('wps_ic_fetch_thumbnails', array($this, 'cron_fetch_thumbnails'), 10, 1);

		// Cron for Bulk
		add_action('wps_ic_cron_compress', array($this, 'cron_compress_bulk'));
	}


	public function cron_compress_bulk() {
    global $wps_ic;

    if (!defined('ABSPATH')) {
      /** Set up WordPress environment */
      require_once(dirname(__FILE__) . '/wp-load.php');
    }

    if (!function_exists('wp_generate_attachment_metadata')) {
      require_once ABSPATH . 'wp-admin/includes/image.php';
    }

    $done = get_option(WPS_IC_BULK_DONE);
    $files = get_option(WPS_IC_BULK);

    $attachments = get_posts(array('post_type' => 'attachment', 'posts_per_page' => '-1', 'post_status' => 'any'));

    if ($attachments) {
      foreach ($attachments as $attachment) {
        $files[$attachment->ID] = $attachment->ID;
      }
    }

    if ($files) {

      // Write Log
      $wps_ic->log->write_log('0', 'Thumbnail cron Started ' . print_r($files, true));

      foreach ($files as $attach_id => $value) {
        $wps_ic->compress->single_cron(array('attachment_id' => $attach_id), 'none');
      }

      // Write Log
      $wps_ic->log->write_log('0', 'Thumbnail cron Ended');
    } else {
      // Write Log
      $wps_ic->log->write_log('0', 'Thumbnail cron Error -  No Files', '0');
    }
  }
	
	
	public function cron_fetch_thumbnails() {
		global $wps_ic;

    $wps_ic->log->write_log('0', 'Fetch Thumbnails Started', '1', 'cron');
    $wps_ic->log->write_log('0', 'Fetch Thumbnails Ended FORCEd', '1', 'cron');
    return;

		if (!defined('ABSPATH')) {
			/** Set up WordPress environment */
			require_once(dirname(__FILE__) . '/wp-load.php');
		}
		
		if (!function_exists('wp_generate_attachment_metadata')) {
			require_once ABSPATH . 'wp-admin/includes/image.php';
		}
		
		$compress_queue = $wps_ic->queue->get_queue('generate_thumbnail');
		
		$uploaddir = wp_upload_dir();
		$uploadfile = $uploaddir['path'] . '/';

		if ($compress_queue) {

      $wps_ic->log->write_log('0', 'Fetch Thumbnails Queue ' . print_r($compress_queue, true), '1', 'cron');

			foreach ($compress_queue as $attach_id => $file) {


        // Generate attachment metadata
        $fullsizepath = get_attached_file($attach_id);
        $attach_data  = wp_generate_attachment_metadata($attach_id, $fullsizepath);
			  wp_update_attachment_metadata($attach_id,$attach_data);
        $wps_ic->queue->remove_queue($attach_id);

				/*
				$check_thumbnails = wp_remote_get($this->api_url . '?fetch_thumbnails=true&api_key=' . $wps_ic::$api_key . '&attachment_ID=' . $attach_id, array('timeout' => 5));

				if (wp_remote_retrieve_response_code($check_thumbnails) == 200) {
					$body = wp_remote_retrieve_body($check_thumbnails);

          $wps_ic->log->write_log('0', 'Fetch Thumbnails Response 200', '1', 'cron');

					$body = json_decode($body, true);

					
					if ($body['success'] == true) {
						
						$data = $body['data'][$attach_id];
						
						if (is_array($data)) {
							foreach ($data as $thumb_size => $thumb_url) {
								$thumbnail_meta = wp_get_attachment_metadata($attach_id);
								
								if ($thumbnail_meta) {
									$sizes = $thumbnail_meta['sizes'];
									$current_size = $sizes[$thumb_size];
									$current_thumbnail = $current_size['file'];
									$currnet_thumbnail_path = $uploadfile . $current_thumbnail;
									
									if (file_exists($currnet_thumbnail_path)) {
										unlink($currnet_thumbnail_path);
									}
									
									$temp_file = download_url($thumb_url, 30);
									copy($temp_file, $currnet_thumbnail_path);
									
								}
								
							}
						}

            $wps_ic->queue->remove_queue($attach_id);
						
						$remove_thumanils = wp_remote_get($this->api_url . '?fetch_thumbnails=true&api_key=' . $wps_ic::$api_key . '&attachment_ID=' . $attach_id . '&remove=true', array('timeout' => 5));
						
						unset($compress_queue[$attach_id]);
						update_option(WPS_IC_CRON_QUEUE, $compress_queue);
						wp_send_json_success();
						
					} else {
						// Not ready yet
            $wps_ic->log->write_log('0', 'Fetch Thumbnails Not Ready Yet', '0', 'cron');
					}
					
				} else {
					wp_send_json_error('Still processing.');
				}*/

			}

      wp_send_json_success();
		}
		
		wp_send_json_error('Nothing to report.');
	}
	
	
	public function cron_regenerate_single_thumbnail($attach_id = '') {

		if (empty($attach_id)) {
			return;
		}
		
		if (!defined('ABSPATH')) {
			/** Set up WordPress environment */
			require_once(dirname(__FILE__) . '/wp-load.php');
		}
		
		if (!function_exists('wp_generate_attachment_metadata')) {
			require_once ABSPATH . 'wp-admin/includes/image.php';
		}

    $uploadfile = get_attached_file($attach_id);
		$attach_data = wp_generate_attachment_metadata($attach_id, $uploadfile);
		wp_update_attachment_metadata($attach_id, $attach_data);
	}
	
	
	public function cron_compress_single_image() {
		global $wps_ic;
		
		$wps_ic = new wps_ic();

		if (!defined('ABSPATH')) {
			/** Set up WordPress environment */
			require_once(dirname(__FILE__) . '/wp-load.php');
		}
		
		if (!function_exists('wp_generate_attachment_metadata')) {
			require_once ABSPATH . 'wp-admin/includes/image.php';
		}

		mail('hrvoje.krbavac@gmail.com', 'cron fire', 'cron na dev');

		$cron_queue = get_option(WPS_IC_CRON_QUEUE);
		
		if ($cron_queue) {
			foreach ($cron_queue as $key => $attach_id) {
				
				$src = wp_get_attachment_image_src($attach_id, 'full');
				if (!empty($src[0])) {
					$wps_ic->compress->single_full(array('attachment_id' => $attach_id), 'none');
					unset($cron_queue[$attach_id]);
					delete_post_meta($attach_id, 'wps_ic_compressing');
				}
			}
			

			update_option(WPS_IC_CRON_QUEUE, $cron_queue);
		}
	}
	
	
	public function cron_regenerate_thumbnails() {
		if (!defined('ABSPATH')) {
			/** Set up WordPress environment */
			require_once(dirname(__FILE__) . '/wp-load.php');
		}
		
		if (!function_exists('wp_generate_attachment_metadata')) {
			require_once ABSPATH . 'wp-admin/includes/image.php';
		}
		
		$cron_queue = get_option(WPS_IC_CRON_QUEUE);
		if ($cron_queue) {
			foreach ($cron_queue as $attach_id => $uploadfile) {
				$attach_data = wp_generate_attachment_metadata($attach_id, $uploadfile);
				wp_update_attachment_metadata($attach_id, $attach_data);
				
				unset($cron_queue[$attach_id]);
			}
			
			update_option(WPS_IC_CRON_QUEUE, $cron_queue);
		}
	}
	
	
}