<?php


/**
 * Class - Enqueues
 */
class wps_ic_enqueues extends wps_ic {

  public static $version;
  public static $slug;


  public function __construct() {
    add_action('admin_enqueue_scripts', array($this, 'enqueue_all'));
  }


  public function enqueue_all() {

    $screen = get_current_screen();

    $this::$version = parent::$version;
    $this::$slug    = parent::$slug;

    if (is_admin()) {
      // Switch Box - Checkbox customizer
      $this->script('switchbox', 'switchbox.js');

      // Settings Area
      $this->script('admin-settings', 'settings.admin.js');


      // Demo Intro - Connect Notice
      if (get_option('wps_ic_demo_connect') || !empty($_GET['deb'])) {
        $this->asset_script('admin-intro', 'intro/intro.min.js');
        $this->asset_style('admin-intro', 'intro/introjs.min.css');
        $this->asset_script('admin-intro-init', 'intro/intro.init.js');
        delete_option('wps_ic_demo_connect');
      }

      if (($screen->base == 'toplevel_page_wps_ic' && get_option('wps_ic_demo_settings')) || !empty($_GET['deb'])) {
        $this->asset_script('admin-intro', 'intro/intro.min.js');
        $this->asset_style('admin-intro', 'intro/introjs.min.css');
        $this->asset_script('admin-intro-init', 'intro/intro.init.js');
        delete_option('wps_ic_demo_settings');
      }


      if (get_option('wps_ic_demo_media') || !empty($_GET['deb'])) {

        if ($screen->base == 'upload' || $screen->base == 'toplevel_page_wps_ic') {
          $this->style('admin-animations', 'animate.css');

          // All Styles
          $this->style('admin', 'admin.styles.css');
          $this->style('admin-media-library', 'admin.media-library.css');
          $this->style('admin', 'admin.styles.css');
          $this->style('admin-animations', 'animate.css');
          $this->style('admin-toggle', 'admin.toggle.css');
          $this->style('admin-notices', 'admin.notices.css');

          // Bootstrap
          $this->asset_style('bootstrap', 'bootstrap/css/bootstrap.css');
          $this->asset_script('bootstrap', 'bootstrap/js/bootstrap.min.js');

          $this->asset_script('admin-demo-init', 'intro/media.init.js');
          $this->asset_style('admin-demo-init', 'intro/media.init.css');
          delete_option('wps_ic_demo_media');
        }
      }


      // Media Library - Bulk Area
      if ($screen->base == 'media_page_wp_compress_bulk') {
        $this->asset_style('admin-fontawesome', 'fontawesome/css/font-awesome.min.css');
        $this->script('verify-api', 'api.js');
        $this->script('media-bulk', 'bulk.js');
        $this->script('exitintent', 'exit.intent.js');
        $this->script('exitintentjs', 'exitintent.js');
      }



			// Media Library Area
      if ($screen->base == 'upload') {
        $this->asset_style('admin-fontawesome', 'fontawesome/css/font-awesome.min.css');
        $this->script('verify-api', 'api.js');
        $this->script('media-library-bulk', 'library.bulk.js');
        $this->script('media-library', 'media-library.js');
        $this->script('exitintent', 'exit.intent.js');
        $this->script('exitintentjs', 'exitintent.js');
      }

			$this->script('admin', 'admin.js');
			$this->style('admin-media-library', 'admin.media-library.css');
			$this->style('admin', 'admin.styles.css');
			$this->style('admin-animations', 'animate.css');
			$this->style('admin-toggle', 'admin.toggle.css');
			$this->style('admin-notices', 'admin.notices.css');

			// Sweetalert
			$this->asset_style('admin-sweetalert', 'sweetalert/sweetalert2.min.css');
			$this->asset_script('admin-sweetalert', 'sweetalert/sweetalert2.min.js');

			// Google Fonts
			wp_enqueue_style($this::$slug . '-google-font', 'https://fonts.googleapis.com/css?family=Montserrat:100,300,400,500,600,700', array(), $this::$version, TRUE);
			wp_enqueue_style($this::$slug . '-google-font', 'https://fonts.googleapis.com/css?family=Open+Sans', array(), $this::$version, TRUE);

			// Featherlight
			$this->asset_style('featherlight', 'featherlight/featherlight.css');
			$this->asset_script('featherlight', 'featherlight/featherlight.js');
			
			// Print footer script
			wp_localize_script('wps_ic-admin', 'wps_ic', array('uri' => WPS_IC_URI));
		}
		

		if ($screen->base == 'upload') {
			// Bootstrap
			$this->asset_style('bootstrap', 'bootstrap/css/bootstrap.css');
			$this->asset_script('bootstrap', 'bootstrap/js/bootstrap.min.js');
		}
		
		
		/**
		 * Main settings page
		 */
		if ($screen->base == 'toplevel_page_wps_ic') {
			$this->asset_script('jquery-ui', 'ui/jquery-ui.min.js');
			$this->asset_script('jquery-ui-init', 'ui/ui.js');
			$this->asset_style('jquery-ui-style', 'ui/jquery-ui.min.css');
			$this->asset_style('jquery-ui-structure', 'ui/jquery-ui.structure.min.css');
			$this->asset_style('jquery-ui-theme', 'ui/jquery-ui.theme.min.css');
		}
	}
	
	
	public function script($name, $filename) {
		wp_enqueue_script($this::$slug . '-' . $name, WPS_IC_URI . 'assets/js/' . $filename, array('jquery'), $this::$version, TRUE);
	}
	
	
	public function style($name, $filename) {
		wp_enqueue_style($this::$slug . '-' . $name, WPS_IC_URI . 'assets/css/' . $filename, array(), $this::$version);
	}
	
	
	public function asset_style($name, $filename) {
		wp_enqueue_style($this::$slug . '-' . $name, WPS_IC_URI . 'assets/' . $filename, array(), $this::$version);
	}
	
	
	public function asset_script($name, $filename) {
		wp_enqueue_script($this::$slug . '-' . $name, WPS_IC_URI . 'assets/' . $filename, array('jquery'), $this::$version, TRUE);
	}
	
	
}