<?php


/**
 * Class - Media Library
 */
class wps_ic_media_library extends wps_ic {

  public $options;


  public function __construct() {

    // Register new columns
    add_filter('manage_media_columns', array(__CLASS__, 'wps_compress_column'));
    add_action('manage_media_custom_column', array(__CLASS__, 'wps_compress_column_value'), 10, 2);

    add_filter('wps_ic_pro_exclude', array(__CLASS__, 'wps_ic_pro_exclude_button'), 10, 2);
    add_filter('wps_ic_pro_include', array(__CLASS__, 'wps_ic_pro_include_button'), 10, 2);

    // Regular WP Media Upload
    add_action('wp_generate_attachment_metadata', array(__CLASS__, 'wps_compress_on_upload'), 10, 2);

    // NextGen Media Upload
    #add_action('ngg_ajax_image_save', array(__CLASS__, 'wps_compress_nextgen_upload'), 10, 1);
    #add_action('ngg_updated_image_meta', array(__CLASS__, 'wps_compress_nextgen_upload2'), 10, 2);

  }


  public static function wps_ic_pro_exclude_button($id, $action = '') {

    $output = '';

    if ($action == 'restore') {

      $output .= '<li><a href="#" class="wps-ic-action-disabled" data-attachment_id="' . $id . '">Exclude Disabled</a></li>';

      #return '<a href="#" title="Exclude Image from Compressing" class="wps-ic-button wps-ic-action-button wps-ic-action-disabled" data-attachment_id="' . $id . '">&nbsp;</a>';
    } else {

      $output .= '<li><a href="#" class="wps-ic-pro-exclude" data-attachment_id="' . $id . '">Exclude</a></li>';

      #return '<a href="#" title="Exclude Image from Compressing" class="wps-ic-button wps-ic-action-button wps-ic-pro-exclude" data-attachment_id="' . $id . '">&nbsp;</a>';
    }

    return $output;
  }


  public static function wps_ic_pro_include_button($id, $action = '') {
    $output = '';

    #$output .= '<li><a href="#" class="wps-ic-pro-include" data-attachment_id="' . $id . '">Include</a></li>';
    $output .= '<button type="button" class="btn btn-success wps-ic-pro-include" data-attachment_id="' . $id . '">Include</button>';

    return $output;

    #return '<a href="#" title="Include Image in Compressing" class="wps-ic-button wps-ic-action-button wps-ic-pro-include" data-attachment_id="' . $id . '">&nbsp;</a>';
  }


  public function wps_compress_nextgen_upload2($id, $meta) {
    global $wps_ic;

    #var_dump($name);
    $wps_ic->log->write('NextGen', $id . ' - ' . print_r($meta, true), true);

    if ($wps_ic->nextgen->using() == true) {

      $gallery_ID = $wps_ic->nextgen->get_picture($id);

      if ($gallery_ID) {
        $gallery_dir = $wps_ic->nextgen->get_gallery_dir($gallery_ID);
        $filename = $wps_ic->nextgen->get_picture($id, $gallery_ID);

        $wps_ic->compress->nextgen_compress(site_url($gallery_dir . '/' . $filename), ABSPATH . $gallery_dir . '/' . $filename);
      } else {
        $wps_ic->log->write('NextGen Failed', $id, true);
      }
    }
  }


  public function wps_compress_nextgen_upload($name) {
    global $wps_ic;

    #var_dump($name);
    $wps_ic->log->write('NextGen', $name, true);

    if ($wps_ic->nextgen->using() == true) {
      /*
            $gallery_dir = $wps_ic->nextgen->get_gallery_dir($galleryid);

            if (!$gallery_dir) return;



            $picture = $wps_ic->nextgen->get_picture($galleryid, $image_ids);

            var_dump($galleryid);
            var_dump($gallery_dir);
            var_dump($image_ids);
            var_dump($picture);*/
    }
  }


  public static function wps_compress_on_upload($meta, $ID = null) {
    global $wps_ic;


    if (!empty($_POST['action'])) {
      if ($_POST['action'] != 'wps_ic_restore') {

        $settings = $wps_ic->options->get_settings();

        if ($settings['optimize_upload'] == '1') {
          $image = wp_get_attachment_image_src($ID, 'full');

          if ($settings['backup'] == '1') {
            $wps_ic->backup->local_backup($ID);
          }

          $wps_ic->compress->single_full(array('attachment_id' => $ID), 'none');
        }

      }
    }
    return $meta;
  }


  public static function wps_compress_column($cols) {
    $old = $cols;
    $cols = array();
    $cols['cb'] = $old['cb'];
    $cols['title'] = $old['title'];
    $cols["wps_ic_all"] = "";
    $cols["wps_ic_actions"] = "";
    #$cols["wps_ic_saved"] = "Compressed Weight";
    #$cols["wps_ic_original"] = "Original Weight"
    $cols['author'] = $old['author'];
    $cols['parent'] = $old['parent'];
    $cols['comments'] = $old['comments'];
    $cols['date'] = $old['date'];

    return $cols;
  }


  public static function wps_compress_column_value($column_name, $id) {
    global $wps_ic;

    $backup_log = get_option($wps_ic->backup->backup_log);
    $compress = get_post_meta($id, 'wps_ic_data', true);
    #$extension = pathinfo($this->original_path . $this->params['filename'], PATHINFO_EXTENSION);

    $excluded = get_post_meta($id, 'wps_ic_exclude', true);

    $logo_compressed = WPS_IC_URI . 'assets/images/compressed.png';
    $logo_uncompressed = WPS_IC_URI . 'assets/images/not-compressed.png';
    $logo_excluded = WPS_IC_URI . 'assets/images/excluded.png';

    $image = wp_get_attachment_image_src($id, 'full');
    $file_name = basename($image[0]);

    $attachment = wp_get_attachment_metadata($id);
    $file_data = get_attached_file($id);
    $type = wp_check_filetype($file_data);

    $allowed_types = array();
    $allowed_types['jpg'] = 'jpg';
    $allowed_types['jpeg'] = 'jpeg';
    $allowed_types['gif'] = 'gif';
    $allowed_types['png'] = 'png';


    if (!in_array($type['ext'], $allowed_types)) {
      // Not compressed
      $file_data = get_attached_file($id);
      $uncompressed_value_num = $uncompressed_value = filesize($file_data);
      $uncompressed_value_num = $uncompressed_value_num / 1000;
      $uncompressed_value = size_format($uncompressed_value, 2);

      $output = '';

      if ($column_name == 'wps_ic_all') {
        $output .= '<div class="wps-ic-excluded">';
        $output .= '<img src="' . $logo_excluded . '" />';
        $output .= '<h5>Excluded</h5>';
        $output .= '</div>';
      } else {
        if ($column_name == 'wps_ic_actions') {

          $output .= '<div class="wps-ic-media-actions-toolbox">';
          $output .= '<ul class="wps-ic-include">';
          $output .= '<li class="no-padding">';
          #$output .= '<a href="#" title="Compress Disabled" class="wps-ic-button wps-ic-action-disabled" data-image="' . $image[0] . '" data-filename="' . $file_name . '" data-image_id="' . $id . '">&nbsp;</a>';

          $output .= '<div class="btn-group">';
          $output .= 'Not supported';
          $output .= '</div>';

          #$output .= '<a href="#wps-ic-compare' . $id . '" title="Compare Disabled" class="wps-ic-button wps-ic-action-disabled" data-original="' . $id . '" data-compressed="' . $id . '">&nbsp;</a>';
          $output .= '</li>';
          $output .= '</ul>';
          $output .= '</div>';
        }
      }
      echo $output;
    } else {

      if ($column_name == 'wps_ic_all') {

        $output = '';

        // Is image in bulk processing already?
        $in_process = get_post_meta($id, 'wps_ic_in_bulk', true);
        $meta = get_post_meta($id, 'wps_ic_data', true);

        if ($in_process == 'true' || (empty($meta['new']) && !empty($compress) && $compress != 'not_able')) {
          $output = '';
          $output .= '<div class="wps-ic-uncompressed">';
          $output .= '<img src="' . $logo_uncompressed . '" />';
          $output .= '<h5>Working...</h5>';
          #$output .= '<button type="button" class="btn btn-info wps-ic-restore-single" data-image_id="' . $id . '">Cancel</button>';
          $output .= '</div>';

          echo '<div class="wp-ic-image-info" id="wp-ic-image-' . $id . '">';
          echo $output;
          echo '</div>';
          return;
        }

        if (empty($attachment)) {
          $attachment_dimensions = 'Unreadable';
        } else {
          $attachment_dimensions = $attachment['width'] . 'x' . $attachment['height'];
        }

        // Not compressed
        $file_data = get_attached_file($id);
        $uncompressed_value_num = $uncompressed_value = filesize($file_data);
        $uncompressed_value_num = $uncompressed_value_num / 1000;
        $uncompressed_value = size_format($uncompressed_value, 2);

        $dimensions = wp_get_attachment_metadata($id);

        if (empty($dimensions) || empty($dimensions['width'])) {
          $dimensions['width'] = '0';
          $dimensions['height'] = '0';
        }

        if (!empty($excluded)) {
          $output .= '<div class="wps-ic-excluded">';
          $output .= '<img src="' . $logo_excluded . '" />';
          $output .= '<h5>Excluded</h5>';
          $output .= '</div>';

        } else {
          if (empty($compress)) {

            $output = '';
            $output .= '<div class="wps-ic-uncompressed">';
            $output .= '<img src="' . $logo_uncompressed . '" />';
            $output .= '<h5>Not Compressed</h5>';
            $output .= '</div>';

            $output .= '<div id="wps-ic-compare' . $id . '" class="lightbox wp-ic-compare"></div>';
          } else if ($compress == 'not_able') {
            $output = '';
            $output .= '<div class="wps-ic-uncompressed">';
            $output .= '<img src="' . $logo_compressed . '" />';
            $output .= '<h5>Already Compressed</h5>';
            $output .= '</div>';

            $output .= '<div id="wps-ic-compare' . $id . '" class="lightbox wp-ic-compare"></div>';
          } else {
            // Saved meta data
            $meta = get_post_meta($id, 'wps_ic_data', true);

            if (empty($meta['old']['data']['width'])) {
              $attachment_dimensions_old = 'Unreadable';
              $attachment_dimensions_new = 'Unreadable';
            } else {
              $attachment_dimensions_old = $meta['old']['data']['width'] . 'x' . $meta['old']['data']['height'];
              $attachment_dimensions_new = $meta['new']['data']['width'] . 'x' . $meta['new']['data']['height'];
            }


            if (empty($meta['old']['size'])) {}


            // Compressed
            $file_data = get_attached_file($id);
            $compressed_value_num = $compressed_value = filesize($file_data);
            $compressed_value = size_format($compressed_value, 2);

            // Old size
            $uncompressed_value_num = $meta['old']['size'] / 1000;
            $uncompressed_value = size_format($meta['old']['size'], 2);

            // Saved total
            $saved_total = $meta['old']['size'] - $compressed_value_num;
            $saved_total = size_format($saved_total, 2);

            // Saved
            $saved = ($compressed_value_num / ($uncompressed_value_num * 1000)) * 100;
            $saved = round(100 - $saved, 0) . '';

            if ($saved == '0') {
              $output = '';
              $output .= '<div class="wps-ic-uncompressed">';
              $output .= '<img src="' . $logo_compressed . '" />';
              $output .= '<h5>Already Compressed</h5>';
              $output .= '</div>';
            } else {
              $output = '';
              $output .= '<div class="wps-ic-compressed">';
              $output .= '<img src="' . $logo_compressed . '" />';
              $output .= '<h5>' . $saved . '%</h5>';
              $output .= '<h5>' . $saved_total . '</h5>';
              $output .= '<h5>Saved</h5>';
              $output .= '</div>';
            }



          }
        }

        // Load times
        $uncompressed_load_time = round($uncompressed_value_num / 640);
        #echo '<div class="wps-ic-image-loading" id="wp-ic-image-loading-' . $id . '" style="display:none;"><img src="' . WPS_IC_URI . 'assets/images/spinner.svg" /></div>';
        echo '<div class="wp-ic-image-info" id="wp-ic-image-' . $id . '">';

        echo $output;

        echo '</div>';

      } else {
        if ($column_name == 'wps_ic_actions') {

          global $wps_ic;
          $response_key = $wps_ic->options->get_option('response_key');

          if (empty($response_key) || !$response_key) {
            $output = '<strong>Please connect to the WP Compress API</strong>';
            echo $output;

            return;
          }

          // Is image in bulk processing already?
          $in_process = get_post_meta($id, 'wps_ic_in_bulk', true);
          $meta = get_post_meta($id, 'wps_ic_data', true);

          if ($in_process == 'true' || (empty($meta['new']) && !empty($compress) && $compress != 'not_able')) {
            echo '<div class="wp-ic-image-actions" id="wp-ic-image-actions-' . $id . '"></div>';
            echo '<div class="wps-ic-image-loading" id="wp-ic-image-loading-' . $id . '"><img src="' . WPS_IC_URI . 'assets/images/spinner.svg" /></div>';

            return;
          }

          // Not compressed
          $file_data = get_attached_file($id);
          $uncompressed_value_num = $uncompressed_value = filesize($file_data);
          $uncompressed_value_num = $uncompressed_value_num / 1000;
          $uncompressed_value = size_format($uncompressed_value, 2);

          $dimensions = wp_get_attachment_metadata($id);

          if (!empty($excluded)) {
            $output = '';

            $output .= '<div class="wps-ic-media-actions-toolbox">';
            $output .= '<ul class="wps-ic-include">';
            $output .= '<li class="no-padding">';

            $output .= '<div class="btn-group">';
            $output .= apply_filters('wps_ic_pro_include', $id);
            $output .= '</div>';

            $output .= '</li>';
            $output .= '</ul>';
            $output .= '</div>';
          } else {
            if (empty($compress)) {
              $output = '';

              $output .= '<div class="wps-ic-media-actions">';
              $output .= '<ul class="wps-ic-noncompressed-icon">';
              $output .= '<li class="wps-ic-weight">
				             <span>' . $uncompressed_value . '</span>
							</li>';
              $output .= '<li class="wps-ic-size">
				             <span>' . $dimensions['width'] . 'x' . $dimensions['height'] . '</span>
							</li>';
              $output .= '<li class="wps-ic-li-no-padding">';
              $output .= '<div class="wps-ic-media-actions-toolbox">';
              $output .= '<ul class="wps-ic-noncompressed-icon">';
              $output .= '<li class="wps-ic-action">';

              $output .= '<div class="btn-group">';
              $output .= '<button type="button" class="btn btn-success wps-ic-compress-single" data-image="' . $image[0] . '" data-filename="' . $file_name . '" data-image_id="' . $id . '">Compress</button>';

              $output .= '<button type="button" class="btn btn-success dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">';
              $output .= '<span class="caret"></span>';
              $output .= '<span class="sr-only">Toggle Dropdown</span>';
              $output .= '</button>';
              $output .= '<ul class="dropdown-menu">';
              #$output .= '<li><a href="#wps-ic-compare' . $id . '" data-original="' . $id . '" data-compressed="' . $id . '" class="wps-ic-compare-single">Preview</a></li>';
              #$output .= '<li role="separator" class="divider"></li>';
              $output .= apply_filters('wps_ic_pro_exclude', $id);
              $output .= '</ul>';
              $output .= '</div>';

              $output .= '</li>';
              $output .= '</ul>';
              $output .= '</div>';
              $output .= '<div style="height:15px;width:100%;"></div>';

              $output .= apply_filters('wps_ic_remote_restore', $id);

              $output .= '</li>';
              $output .= '</ul>';

              $output .= '</div>';

              $output .= '<div id="wps-ic-compare' . $id . '" class="lightbox wp-ic-compare"></div>';
              $output .= '<div id="wps-ic-pro-compare' . $id . '" class="lightbox wp-ic-compare"></div>';
            } else if ($compress == 'not_able') {
              $output = '';

              $output .= '<div class="wps-ic-media-actions">';
              $output .= '<ul class="wps-ic-noncompressed-icon">';
              $output .= '<li class="wps-ic-weight">
				             <span>' . $uncompressed_value . '</span>
							</li>';
              $output .= '<li class="wps-ic-size">
				             <span>' . $dimensions['width'] . 'x' . $dimensions['height'] . '</span>
							</li>';
              $output .= '<li class="wps-ic-li-no-padding">';

              $output .= '<div class="wps-ic-media-actions-toolbox">';
              $output .= '<ul class="wps-ic-noncompressed-icon">';
              $output .= '<li class="wps-ic-action">';

              $output .= '<button type="button" class="btn btn-info wps-ic-reset-single" data-image_id="' . $id . '">Reset</button>';

              $output .= '</li>';
              $output .= '</ul>';
              $output .= '</div>';
              $output .= '<div style="height:15px;width:100%;"></div>';

              $output .= apply_filters('wps_ic_remote_restore', $id);

              $output .= '</li>';
              $output .= '</ul>';

              $output .= '</div>';

              $output .= '</li>';
              $output .= '</ul>';
              $output .= '</div>';

              $output .= '<div id="wps-ic-compare' . $id . '" class="lightbox wp-ic-compare"></div>';
              $output .= '<div id="wps-ic-pro-compare' . $id . '" class="lightbox wp-ic-compare"></div>';
            } else {
              // Saved meta data
              $meta = get_post_meta($id, 'wps_ic_data', true);

              if (empty($meta['old']['data']['width'])) {
                $attachment_dimensions_old = 'Unreadable';
                $attachment_dimensions_new = 'Unreadable';
              } else {
                $attachment_dimensions_old = $meta['old']['data']['width'] . 'x' . $meta['old']['data']['height'];
                $attachment_dimensions_new = $meta['new']['data']['width'] . 'x' . $meta['new']['data']['height'];
              }

              // Compressed
              $file_data = get_attached_file($id);
              $compressed_value_num = $compressed_value = filesize($file_data);
              $compressed_value = size_format($compressed_value, 2);

              // Old size
              $uncompressed_value_num = $meta['old']['size'] / 1000;
              $uncompressed_value = size_format($meta['old']['size'], 2);

              // Saved
              $saved = ($compressed_value_num / ($uncompressed_value_num * 1000)) * 100;
              $saved = round(100 - $saved, 0) . '%';

              $output = '';

              $output .= '<div class="wps-ic-media-actions">';
              $output .= '<div class="wps-ic-half-media-actions">';
              $output .= '<ul class="wps-ic-noncompressed-icon">';

              $output .= '<li class="wps-ic-weight"><span class="strike">' . $uncompressed_value . '</span></li>';
              $output .= '<li class="wps-ic-size"><span>' . $attachment_dimensions_new . '</span></li>';

              $output .= '</ul>';
              $output .= '</div>';
              $output .= '<div class="wps-ic-half-media-actions">';
              $output .= '<ul class="wps-ic-noncompressed-icon">';
              $output .= '</li>';

              $output .= '<li class="wps-ic-size-compressed"><span>' . $compressed_value . '</span></li>';
              #$output .= '<li class="wps-ic-time"><span>' . $time . '</span></li>';

              $output .= '</ul>';
              $output .= '</div>';

              $output .= '<div class="wps-ic-media-actions-toolbox">';
              $output .= '<ul class="wps-ic-noncompressed-icon">';
              $output .= '<li class="wps-ic-action">';

              $output .= '<button type="button" class="btn btn-info wps-ic-restore-single" data-image_id="' . $id . '">Restore</button>';

              $output .= '&nbsp;&nbsp;';
              $output .= apply_filters('wps_ic_remote_restore', $id);

              $output .= '</li>';
              $output .= '</ul>';
              $output .= '</div>';


              $output .= '</div>';

            }
          }

          // Load times
          $uncompressed_load_time = round($uncompressed_value_num / 640);
          echo '<div class="wps-ic-image-loading" id="wp-ic-image-loading-' . $id . '" style="display:none;"><img src="' . WPS_IC_URI . 'assets/images/spinner.svg" /></div>';
          echo '<div class="wp-ic-image-actions" id="wp-ic-image-actions-' . $id . '">';

          echo $output;

          echo '</div>';
        }
      }
    }
  }


}