<?php


/**
 * Class - Notices
 */
class wps_ic_notices extends wps_ic {

  public $options;
  public $templates;

  public function __construct() {

    $this->options = new wps_ic_options();
    $this->templates = new wps_ic_templates();

    // Connect to API Notice
    $this->connect_api_notice();
  }


  public function connect_api_notice() {
    $options = get_option(WPS_IC_SETTINGS);
    add_action('admin_notices', array($this, 'activate_list_mode'));

    if ($this->options->get_option('response_key') == '') {
      add_action('all_admin_notices', array($this, 'connect_api_message'));
    }

    if (!file_exists(ABSPATH . 'wp-content/wps_ic_backup/') && $options['backup'] != '0') {
      add_action('admin_notices', array($this, 'missing_backup_folder'));
    }
  }


  /**
   * Render List Media Library Notice
   */
  public function activate_list_mode() {
    $this->templates->get_notice('activate_list_mode');
  }

  /**
   * Render Missing Backup folder message
   */
  public function missing_backup_folder() {
    $this->templates->get_notice('missing_backup_folder');
  }


  /**
   * Render Api Connect Notice
   */
  public function connect_api_message() {
    $screen = get_current_screen();
    if ($screen->id != 'toplevel_page_wps_ic') {
      $this->templates->get_notice('connect_api_message');
    }
  }


}