<?php


/**
 * Class - Popups
 */
class wps_ic_popups extends wps_ic {

  public $options;
  public $api_url;


  public function __construct() {

    if (is_admin()) {

      add_action('admin_print_footer_scripts', array(__CLASS__, 'print_popups'));

    }

  }


  public static function print_popups() {
    self::blocked();
    self::no_credits();
  }


  public static function blocked() {
    global $wps_ic;

    $ajax      = new wps_ic_ajax();
    $referrals = $ajax->wps_ic_api_referrals();

    echo '<div id="ic_blocked_popup" style="display:none;">';
    echo '<div class="ic-popup">';
    echo '<h3>It seems that you’ve exceeded the quota for personal usage - to continue, please upgrade to a professional license.</h3><br/>';

    echo '<br/>';

    echo '<div style="display:inline-block;width: 45%;vertical-align: top;border-right: 1px solid #d1d1d1;margin-right: 2%;padding-right: 2%;">';
    echo '<h4>Share WP Compress</h4>';

    if ($referrals->total_referrals < 1) {
      echo '<h5>Get an additional 2,500 credits with your first referral.</h5>';
    } else {
      echo '<h5>Get an additional 500 credits for every friend you refer.</h5>';
    }
    echo '<br/>';
    echo '<br/>';
    echo '<strong>Your Referral Link</strong>';
    echo '<br/>';
    echo '<a href="https://WPCompress.com/?ref=' . $referrals->refID . '">https://WPCompress.com/?ref=' . $referrals->refID . '</a>';

    $share_url = 'https://wpcompress.com/?ref=' . $referrals->refID;
    $share_url = urlencode($share_url);

    echo '<div class="ic-social-shares">';
    echo '<a href="https://www.facebook.com/sharer/sharer.php?u=' . $share_url . '" target="_blank"><i class="fa fa-facebook"></i></a>';
    echo '<a href="https://twitter.com/home?status=' . $share_url . '" target="_blank"><i class="fa fa-twitter"></i></a>';
    echo '<a href="https://www.linkedin.com/shareArticle?mini=true&url=' . $share_url . '&title=WP %20Compress&summary=&source=" target="_blank"><i class="fa fa-linkedin"></i></a>';
    echo '<a href="mailto:?&subject=I\'m saving by using WP Compress, ' . $share_url . ' Join me!" target="_blank"><i class="fa fa-envelope"></i></a>';

    echo '</div>';


    echo '<div style="display:inline-block;width:48%;vertical-align:top;">';
    echo '<h4>Professional License</h4>';
    echo '<h1>$29/year</h1>';
    echo '<h5>Unlimited Images, AI Compression and More</h5>';
    echo '<a href="https://wpcompress.com/upgrade/" class="popup-btn">Upgrade to Pro</a>';
    echo '</div>';

    echo '<div>';
    echo '<h6>We aim to be reasonable, check out our <a href="https://wpcompress.com/fup">Fair Usage Policy</a>.</h6>';
    echo '</div>';

    echo '</div>';

    echo '</div>';
  }


  public static function no_credits() {
    $ajax      = new wps_ic_ajax();
    $referrals = $ajax->wps_ic_api_referrals();

    echo '<div id="ic_no_credits_popup" style="display:none;">';
    echo '<div class="ic-popup">';
    echo '<h3>Uh oh, it looks like you’ve run out of credits.</h3><br/>';
    echo '<h5>You can continue for free by referring friends, or you can upgrade to our Professional plan for unlimited images, faster compression and extended backups.</h5>';

    echo '<br/>';

    echo '<div style="display:inline-block;width: 45%;vertical-align: top;border-right: 1px solid #d1d1d1;margin-right: 2%;padding-right: 2%;">';
    echo '<h4>Share WP Compress</h4>';
    if ($referrals->total_referrals < 1) {
      echo '<h5>Get an additional 2,500 credits with your first referral.</h5>';
    } else {
      echo '<h5>Get an additional 500 credits for every friend you refer.</h5>';
    }
    echo '<br/>';
    echo '<br/>';
    echo '<strong>Your Referral Link</strong>';
    echo '<a href="https://wpcompress.com/?ref=' . $referrals->refID . '">https://wpcompress.com/?ref=' . $referrals->refID . '</a>';

    $share_url = 'https://wpcompress.com/?ref=' . $referrals->refID;
    $share_url = urlencode($share_url);

    echo '<div class="ic-social-shares">';
    echo '<a href="https://www.facebook.com/sharer/sharer.php?u=' . $share_url . '" target="_blank"><i class="fa fa-facebook"></i></a>';
    echo '<a href="https://twitter.com/home?status=' . $share_url . '" target="_blank"><i class="fa fa-twitter"></i></a>';
    echo '<a href="https://www.linkedin.com/shareArticle?mini=true&url=' . $share_url . '&title=WP %20Compress&summary=&source=" target="_blank"><i class="fa fa-linkedin"></i></a>';
    echo '<a href="mailto:?body=I\'m saving by using WP Compress, ' . $share_url . ' Join me!" target="_blank"><i class="fa fa-envelope"></i></a>';
    echo '</div>';

    echo '</div>';

    echo '<div style="display:inline-block;width:48%;vertical-align:top;">';
    echo '<h4>Professional License</h4>';
    echo '<h1>$29/year</h1>';
    echo '<h5>Unlimited Images, AI Compression and More</h5>';
    echo '<a href="https://wpcompress.com/upgrade/" class="popup-btn">Upgrade to Pro</a>';
    echo '</div>';


    echo '<div>';
    echo '<h6>We aim to be reasonable, check out our <a href="https://wpcompress.com/fup">Fair Usage Policy</a>.</h6>';
    echo '</div>';
    echo '</div>';

    echo '</div>';
  }





}