<?php


/**
 * Class - Requests
 */
class wps_ic_requests {

  public static $api_key;
  public $options;

  public function __construct() {
    global $wps_ic;

    $options = new wps_ic_options();
    $log = new wps_ic_log();

    $options       = $options->get_option();
    self::$api_key = $options['api_key'];

    if (is_admin()) {
      if ( ! empty($_GET['unlock_restore'])) {

        global $wps_ic, $wpdb;

        $attachments = get_posts(array('post_type' => 'attachment', 'posts_per_page' => - 1));
        if ($attachments) {
          foreach ($attachments as $attachment) {

            // Is image in bulk processing already?
            $compress = get_post_meta($attachment->ID, 'wps_ic_data', true);
            $in_process = get_post_meta($attachment->ID, 'wps_ic_in_bulk', true);
            $meta = get_post_meta($attachment->ID, 'wps_ic_data', true);

            if ($in_process == 'true' || (empty($meta['new']) && !empty($compress))) {
              delete_post_meta($attachment->ID, 'wps_ic_in_bulk');
              #delete_post_meta($attachment->ID, 'wps_ic_data');
            }

          }
          // End it
          wp_send_json_error();
        }

      }
      if ( ! empty($_GET['unlock_images'])) {

          global $wps_ic, $wpdb;

          $attachments = get_posts(array('post_type' => 'attachment', 'posts_per_page' => - 1));
          if ($attachments) {
            foreach ($attachments as $attachment) {

              // Is image in bulk processing already?
              $compress = get_post_meta($attachment->ID, 'wps_ic_data', true);
              $in_process = get_post_meta($attachment->ID, 'wps_ic_in_bulk', true);
              $meta = get_post_meta($attachment->ID, 'wps_ic_data', true);

              if ($in_process == 'true' || (empty($meta['new']) && !empty($compress))) {
                delete_post_meta($attachment->ID, 'wps_ic_in_bulk');
                delete_post_meta($attachment->ID, 'wps_ic_data');
              }

            }
            // End it
            wp_send_json_error();
          }

      }
    }

    if ( ! empty($_GET['secret_key'])) {

      // A little Cleanup
      $data = array();
      foreach ($_GET as $key => $value) {
        $data[ $key ] = sanitize_text_field($value);
      }

      $log->write('Thumbnails Call', 'API Finished Thumbnails! ' . $data['secret_key']  . ' == ' . self::$api_key);

      if ($data['secret_key'] == self::$api_key) {

        if (!empty($data['thumbs'])) {

          if ( ! function_exists('download_url')) {
            require_once(ABSPATH . "wp-admin" . '/includes/image.php');
            require_once(ABSPATH . "wp-admin" . '/includes/file.php');
            require_once(ABSPATH . "wp-admin" . '/includes/media.php');
          }

          #$log->write('Thumbnails Call', 'Thumbs ' . print_r($data['thumbs'], true));

          $attachment_ID = $data['attachment_ID'];

          $request = stripslashes($data['thumbs']);
          $request = json_decode($request);


          // Fetch existing thumbnails
          $sizes  = get_intermediate_image_sizes();

          if (is_array($sizes)) {
            foreach ($sizes as $key => $size) {
              $thumbs[ $size ] = wp_get_attachment_image_src($attachment_ID, $size);
              $thumbs[ $size ] = $thumbs[ $size ][0];
              $thumbs[ $size ] = str_replace(site_url('/'), '', $thumbs[ $size ]);
            }
          }

          // Parse request
          $parse = array();
          foreach ($request as $attachment_ID => $compressed_thumbs) {

            foreach ($compressed_thumbs as $k => $thumb) {
              foreach ($thumb as $key => $value) {
                $thumb_url = $value;
                $thumb_name = basename($thumb_url);
                $parse[$thumb_name] = $thumb_url;

              }
            }

          }

          if ($thumbs && $parse) {

            $log->write('Thumbnails Fetch', 'Started');

            foreach ($thumbs as $size => $original_thumb_path) {
              $original_basename = basename($original_thumb_path);

              if (file_exists(ABSPATH . $original_thumb_path)) {

                $log->write('Thumbnails Fetch', 'File EXists ' . print_r($parse[$original_basename], true));

                if (!empty($parse[$original_basename])) {

                  $log->write('Thumbnails Fetch', 'OLD File ' . print_r(ABSPATH . $original_thumb_path, true));

                  $temp = download_url($parse[$original_basename], 60);

                  if ($temp && filesize($temp) < filesize(ABSPATH . $original_thumb_path)) {
                    $log->write('Thumbnails Fetch', 'Smaller Thumb');
                    unlink(ABSPATH . $original_thumb_path);
                    copy($temp, ABSPATH . $original_thumb_path);
                  } else {
                    $log->write('Thumbnails Fetch', 'Larger Thumb');
                  }
                } else {
                  $log->write('Thumbnails Fetch', 'Empty $parse ' . print_r($parse, true));
                  $log->write('Thumbnails Fetch', 'Empty $parse ' . print_r($original_basename, true));
                }
              } else {
                $log->write('Thumbnails Fetch', 'File NOT EXists ' . $original_thumb_path);
              }

            }
          }

          die();




          #self::generate_thumbnails($data['attachment_ID']);
        }

        if ( ! empty($data['uri'])) {

          $log->write('URI Call', 'URI ' . print_r($data['uri'], true));

          // Download image
          self::fetch_compressed($data['uri'], $data['attachment_ID']);
        }

      } else {
        // Hacked?
      }

      die('x');

    }

  }


  public static function generate_thumbnails($thumbnail, $attachment_ID) {
    if (!defined('ABSPATH')) {
      /** Set up WordPress environment */
      require_once(dirname(__FILE__) . '/wp-load.php');
    }

    if (!function_exists('wp_generate_attachment_metadata')) {
      require_once ABSPATH . 'wp-admin/includes/image.php';
    }

    $uploadfile = get_attached_file($attachment_ID);

    if (!empty($uploadfile)) {
      $attach_data = wp_generate_attachment_metadata($attachment_ID, $uploadfile);
      wp_update_attachment_metadata($attachment_ID, $attach_data);
      wp_send_json_success();
    } else {
      wp_send_json_error();
    }
  }


  /**
   * Fetch compressed image from given url and put it to attachment ID
   *
   * @param $uri
   * @param $attachment_ID
   */
  public static function fetch_compressed($uri, $attachment_ID) {
    global $wps_ic;

    #var_dump($wps_ic);
    $backup = new wps_ic_backup();

    // Get upload directory path
    $uploaddir = wp_upload_dir();

    if ( ! function_exists('download_url')) {
      require_once(ABSPATH . "wp-admin" . '/includes/image.php');
      require_once(ABSPATH . "wp-admin" . '/includes/file.php');
      require_once(ABSPATH . "wp-admin" . '/includes/media.php');
    }

    if ( ! function_exists('update_option')) {
      require_once(ABSPATH . "wp-includes" . '/option.php');
    }

    // Find file with attachment_ID
    $file = wp_get_attachment_image_src($attachment_ID, 'full');

    if (empty($file) || ! $file) {
      wp_send_json_error('File not found.');
    }

    // Is allowed type or excluded?
    if (self::is_allowed_type($attachment_ID) || self::is_excluded($attachment_ID)) {
      wp_send_json_error('File not allowed type or excluded.');
    }

    // Does backup exist?
    $backup_exists = self::backup_exists($attachment_ID);
    if ( ! $backup_exists || empty($backup_exists)) {
      #$backup->local_backup($attachment_ID);
    }

    // Gather thumbnails so we know what we need to replace
    $thumbnails = self::get_all_thumbnails($attachment_ID);

    // Get remote image and download it
    $remote_image = wp_remote_get($uri, array('timeout' => 120));

    if (wp_remote_retrieve_response_code($remote_image) == 200) {
      $body = wp_remote_retrieve_body($remote_image);

      $uploadfile = $uploaddir['path'] . '/' . basename($file[0]);

      // Download remote file to temp
      $temp_file = download_url($uri, 30);

      if ($temp_file) {
        clearstatcache();

        // Fetch old image details
        $compress_data                = array();
        $file_data                    = get_attached_file($attachment_ID);
        $compress_data['old']['size'] = filesize($file_data);
        $compress_data['old']['data'] = wp_get_attachment_metadata($attachment_ID);

        // First delete the current file
        if (is_writable($uploadfile)) {
          // Everything OK; delete the file
          unlink($uploadfile);
        }

        if (file_exists($uploadfile)) {
          unlink($uploadfile);
        }

        // Move new file to old location/name
        copy($temp_file, $uploadfile);

        // Chmod new file to original file permissions
        @chmod($uploadfile, 0644);

        // Make thumb and/or update metadata
        wp_update_attachment_metadata((int)$attachment_ID, wp_generate_attachment_metadata((int)$attachment_ID, $uploadfile));

        // Trigger possible updates on CDN and other plugins
        update_attached_file((int)$attachment_ID, $uploadfile);

        // Run cron for thumbnails
        #wp_schedule_single_event(time(), 'wps_ic_fetch_thumbnails');

        // Fetch new image details
        $file_data                    = get_attached_file($attachment_ID);
        $compress_data['new']['size'] = filesize($file_data);
        $compress_data['new']['data'] = wp_get_attachment_metadata($attachment_ID);

        // Update Stats
        $data        = get_post_meta($attachment_ID, 'wps_ic_data', true);
        $wps_ic->stats->update($data['old']['size'], $body['compressed']['full']['size']);

        // Update compress data
        update_post_meta($attachment_ID, 'wps_ic_compressed', 'true');
        update_post_meta($attachment_ID, 'wps_ic_data', $compress_data);

        // Remove unnecessary data
        delete_post_meta($attachment_ID, 'wps_ic_in_bulk');
        delete_post_meta($attachment_ID, 'wps_ic_compressing');

        // End Timer
        $timer = microtime(true);
        $start = get_transient('wps_ic_' . $attachment_ID);
        $end   = round($timer - $start, 1);
        update_post_meta($attachment_ID, 'wps_ic_time', $end . ' s');

        $compressed_items = get_option('wps_ic_compressed');
        $compressed_items['waiting'][] = $attachment_ID;
        update_option('wps_ic_compressed', $compressed_items);

        clearstatcache();
      }

    }

    // Update time
    $times = get_post_meta($attachment_ID, 'wps_ic_times', true);
    $times['api_request_ended'] = microtime(true);
    update_post_meta($attachment_ID, 'wps_ic_times', $times);

  }

  /**
   * Is image type allowed?
   *
   * @param $attachment_id
   *
   * @return bool
   */
  public static function is_allowed_type($attachment_id) {
    $file_data = get_attached_file($attachment_id);
    $type      = wp_check_filetype($file_data);

    $allowed_types         = array();
    $allowed_types['jpg']  = 'jpg';
    $allowed_types['jpeg'] = 'jpeg';
    $allowed_types['gif']  = 'gif';
    $allowed_types['png']  = 'png';

    if ( ! in_array($type['ext'], $allowed_types)) {
      return true;
    }

    return false;
  }


  /**
   * Is image excluded?
   *
   * @param $attachment_id
   *
   * @return bool
   */
  public static function is_excluded($attachment_id) {
    $excluded = get_post_meta($attachment_id, 'wps_ic_exclude', true);
    if ( ! empty($excluded)) {

      // Get bulked files for compress background
      $bulk_queue = get_option(WPS_IC_BULK);

      // Remove from Bulk Compress Background
      unset($bulk_queue[ $attachment_id ]);
      update_option(WPS_IC_BULK, $bulk_queue);

      return true;
    }

    return false;
  }

  /**
   * Does the backup already exist?
   *
   * @param $attachment_id
   *
   * @return array|null|object
   */
  public static function backup_exists($attachment_id) {
    global $wpdb, $wps_ic;

    $backup_Class = new wps_ic_backup();

    $backup = $wpdb->prepare("SELECT * FROM " . $backup_Class->backup_log . " WHERE attachment_ID=%s ORDER BY ID DESC LIMIT 1", $attachment_id);

    return $wpdb->get_results($backup);
  }

  /**
   * Gather all possible thumbnails on the server
   *
   * @param $attachment_id
   *
   * @return mixed|string|void
   */
  public static function get_all_thumbnails($attachment_id) {
    $thumbs = array();
    $sizes  = get_intermediate_image_sizes();

    $thumbs['full'] = wp_get_attachment_image_src($attachment_id, 'full');
    $thumbs['full'] = $thumbs['full'][0];

    if (is_array($sizes)) {
      foreach ($sizes as $key => $size) {
        $thumbs[ $size ] = wp_get_attachment_image_src($attachment_id, $size);
        $thumbs[ $size ] = $thumbs[ $size ][0];
      }
    }

    return json_encode($thumbs);
  }


}