<?php


/**
 * Class - Unlocks
 */
class wps_ic_unlocks extends wps_ic {

  public $options;
  public $api_url;


  public function __construct() {

    if (is_admin()) {
      $referrals = $this->total_referrals();

      if ($referrals > 0) {
        $this->unlocks();
      }

    }

  }


  public function total_referrals() {
    global $wps_ic;

    $options = get_option(WPS_IC_OPTIONS);

    // API Key
    $apikey = $options['api_key'];

    // Setup URI
    $uri = 'http://keys.wpcompress.com/';
    $uri .= '?action=referrals';
    $uri .= '&apikey=' . $apikey;
    $uri .= '&site=' . urlencode(site_url());

    // Verify API Key is our database and user has is confirmed getresponse
    $get = wp_remote_get($uri);

    if (wp_remote_retrieve_response_code($get) == 200) {
      $body = wp_remote_retrieve_body($get);
      $body = json_decode($body);

      if (!empty($body->success)) {
        if ($body->success == true && ! empty($body->data)) {
          return $body->data->total_referrals;
        }
      }

      return '0';
    }
  }


  public function unlocks() {
    $options = new wps_ic_options();
    #$options = get_option(WPS_IC_SETTINGS);
/*
    if (empty($options['double_up'])) {
      $options['double_up'] = '1';
      update_option(WPS_IC_SETTINGS, $options);
    }*/

    // API Key
    $apikey = $options->get_option('api_key');

    // Setup URI
    $uri = 'http://keys.wpcompress.com/';
    $uri .= '?action=unlocks';
    $uri .= '&apikey=' . $apikey;
    $uri .= '&site=' . urlencode(site_url());

    // Verify API Key is our database and user has is confirmed getresponse
    $get = wp_remote_get($uri);

    #var_dump(wp_remote_retrieve_body($get));

    if (wp_remote_retrieve_response_code($get) == 200) {
      $body = wp_remote_retrieve_body($get);
      $body = json_decode($body, true);

      if ($body['success'] == true && !empty($body['data'])) {
        $update_options = get_option(WPS_IC_SETTINGS);
        $update_options['unlocks'] = $body['data'];
        update_option(WPS_IC_SETTINGS, $update_options);

        if (!empty($update_options['unlocks']) && !empty($update_options['unlocks']['night_owl'])) {

          if ( ! wp_next_scheduled('wps_no_worker')) {
            wp_schedule_event(time(), 'hourly', 'wps_no_worker');
          }

        }

      }

    }

  }


  /**
   * Two Times faster compression
   */
  public function lightspeed() {
    $options = get_option(WPS_IC_SETTINGS);

    if (empty($options['priority_compression'])) {
      $options['priority_compression'] = '1';
      update_option(WPS_IC_SETTINGS, $options);
    }
  }


  public function nightowl() {

  }


  public function hyperspeed() {

  }



}