<div class="wrap wps_ic_wrap">
  <div class="wps_ic_logo">
    <img src="<?php echo WPS_IC_URI; ?>assets/images/logo-small.png" alt="WP Compress"/>
    <h1>Bulk Image Optimization</h1>
  </div>
  <hr/>

  <div class="wps-ic-media-bulk" id="wps-ic-media-bulk-instructions">
    <div class="wps-ic-bulk-complete" style="display: none;">
      <h1 class="wps-ic-compress-not-started">Bulk Optimization Complete</h1>
      <p class="">All your images have been optimized.</p>
      <a href="<?php echo admin_url('upload.php?mode=list'); ?>" class="button button-primary">Go to Media Library</a>
    </div>
    <div class="wps-ic-bulk-not-started">
      <h1 class="wps-ic-compress-not-started">Click compress to get started...</h1>
      <h1 class="wps-ic-compress-started" style="display: none;">Media library optimization in progress...</h1>
      <p class="">Click compress below to start optimizing your images. <br/>You can resume working in your WP Admin in a new tab, but leave this window open until compression is completed. <br/>You may stop bulk compression at any time or restore
        images from your media library as needed.</p>


      <?php
      if ( ! file_exists(ABSPATH . 'wp-content/wps_ic_backup/')) {
        ?>
        <div class="wps-critical-error">
          <h1>Critical Error</h1>
          <p>We were <strong>NOT</strong> able to create your backup folder, please create the older by hand in:<strong><?php echo 'wp-content/wps_ic_backup/'; ?></strong>
          </p>
        </div>
        <?php
      }

      global $wps_ic, $wpdb;

      $media = $wpdb->prepare("SELECT * FROM " . $wpdb->posts . " WHERE post_type=%s", 'attachment');
      $media = $wpdb->query($media);

      global $wps_ic;
      $response_key = $wps_ic->options->get_option('response_key');

      /**
       * Check if API is online
       */
      $api_online = false;
      $call       = wp_remote_get('http://devapi.wpcompress.com', array('timeout' => 5));
      if (wp_remote_retrieve_response_code($call) == 200) {
        $body = wp_remote_retrieve_body($call);
        $body = json_decode($body);

        if ($body->success == false) {
          $api_online = true;
        }
      }

      if (empty($response_key) || ! $response_key) {
        ?>
        <div class="wps-critical-error">
          <h1>Critical Error</h1>
          <p>You have <strong>NOT</strong> authorized your plugin with our API! It's free!</p>
        </div>
        <?php
      } else if ( ! $api_online) {
        ?>
        <div class="wps-critical-error">
          <h1>Critical Error</h1>
          <p>We are currently having issues with our API!</p>
        </div>
        <?php
      } else if ( ! $media) {
        ?>
        <div class="wps-critical-error">
          <h1>Critical Error</h1>
          <p>Seems like you don't have any images in media library!</strong>
          </p>
        </div>
        <?php
      } else {
        ?>
        <a href="#" class="button button-primary wps-ic-compress-bulk">Compress</a>
        <a href="#" class="button button-primary wps-ic-bulk-stop" style="display: none;">Stop</a>
        <!--<a href="#" class="button button-primary wps-ic-compress-queue-clear">Clear Queue</a>-->
      <?php } ?>
    </div>
  </div>

  <div class="wps-ic-media-bulk wps-ic-bulk-progress-container" style="display: none;">

    <div class="wps-ic-inner wps-ic-bulk-info" style="display: none;">
    </div>

    <div class="wps-ic-inner wps-ic-bulk-prep">
      <h1>
        <ul>
          <li class="current init">Scanning Media Library...</li>
          <li style="display: none;">Optimizing Images...</li>
        </ul>
      </h1>
    </div>

    <div class="wps-ic-inner wps-ic-spinner">
      <img src="<?php echo WPS_IC_URI; ?>assets/images/spinner.svg" />
    </div>

    <div class="wps-ic-inner wps-ic-bulk-progress" style="display: none;">
      <div class="wps-ic-bulk-progress-bar">
        <div class="wps-ic-bulk-progress-bar-inner">
          <span>0%</span>
        </div>
      </div>
    </div>

    <div class="wps-ic-inner wps-ic-bulk-savings">
      <div class="inner">


      </div>
    </div>

    <?php
    $text = "I've saved {social_saved} using WP Compress to optimize my images! Make your WordPress website load lightning fast for FREE at https://WPCompress.com";
    $text = urlencode($text);
    $text = str_replace('%7B', '{', $text);
    $text = str_replace('%7D', '}', $text);
    ?>

    <div class="wps-ic-share">
      <ul>
        <li class="wps-ic-facebook"><a href="https://www.facebook.com/sharer/sharer.php?u=https://www.wpcompress.com" target="_blank"><img src="<?php echo WPS_IC_URI; ?>assets/images/social-icons/fb.png" alt="Twitter"></a></li>
        <li class="wps-ic-twitter"><a href="https://twitter.com/home?status=<?php echo $text; ?>" target="_blank"><img src="<?php echo WPS_IC_URI; ?>assets/images/social-icons/twitter.png" alt="Twitter"></a></li>
        <li class="wps-ic-linkedin"><a href="https://www.linkedin.com/shareArticle?mini=true&url=https%3A//www.wpcompress.com&title=WP%20Compress&summary=<?php echo $text; ?>&source=" target="_blank"><img
              src="<?php echo WPS_IC_URI; ?>assets/images/social-icons/linkedin.png" alt="LinkedIn"></a></li>
        <li class="wps-ic-mail"><a href="mailto:?&subject=I'm using WP Compress!&body=<?php echo $text; ?>" target="_blank"><img src="<?php echo WPS_IC_URI; ?>assets/images/social-icons/mail.png" alt="Mail"></a></li>
      </ul>
    </div>

    <div class="wps-ic-credits">
      <span>Optimized with love by</span> <img src="<?php echo WPS_IC_URI; ?>assets/images/credits.png"/>
    </div>

  </div>

</div>