<?php
global $wps_ic, $wpdb;
$response_key = $wps_ic->options->get_option('response_key');
$stats        = $wpdb->get_results("SELECT SUM((saved*count)) as sum_saved, COUNT(ID) as count, SUM(percent_saved) as per_saved FROM " . $wpdb->prefix . "ic_compressed ORDER BY ID");

// Check if has additional features
$orp = $wps_ic->ajax->wps_ic_orp();
#var_dump($orp);

$ajax      = new wps_ic_ajax();
$referrals = $ajax->wps_ic_api_referrals();
$credits   = $ajax->wps_ic_api_credits();

$options = get_option(WPS_IC_SETTINGS);
if (!empty($options['unlocks'])) {
  $unlocks = $options['unlocks'];
} else {
  $unlocks = array();
}

?>
<div class="wrap">
  <div class="wps_ic_wrap wps_ic_subscribe_container">

    <div class="wp-compress-header">
      <div class="wp-ic-logo-container">
        <div class="wp-compress-logo">
          <img src="<?php echo WPS_IC_URI; ?>/assets/images/logo-small.png"/>
          <div class="wp-ic-logo-inner">
            <h3>WP Compress</h3>
          </div>
        </div>
      </div>


      <div class="wp-ic-faq-container">

        <div class="powerups-learn">
          <h5>PowerUps</h5>
          <a href="https://wpcompress.com/powerups">Learn More</a>
        </div>

        <ul class="ic_unlocks">
          <li>
            <?php
            if (empty($response_key) || ! $response_key) {
              ?>
              <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/activated_off.png" alt="Activated"/>
            <?php } else { ?>
              <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/activated_onn.png" alt="Activated"/>
            <?php } ?>
            <strong>Activated</strong>
          </li>
          <li>
            <?php
            if (!empty($unlocks) && !empty($unlocks['double_up'])) {
            ?>
            <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/double_up_on.png" alt="Double Up"/>
            <?php } else { ?>
              <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/double_up_off.png" alt="Double Up"/>
            <?php } ?>
            <strong>Double Up</strong>
          </li>
          <li>
            <?php
            if (!empty($unlocks) && !empty($unlocks['lightspeed'])) {
              ?>
              <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/lightspeed_on.png" alt="LightSpeed"/>
            <?php } else { ?>
              <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/lightspeed_off.png" alt="LightSpeed"/>
            <?php } ?>
            <strong>LightSpeed</strong>
          </li>
          <li>
            <?php
            if (!empty($unlocks) && !empty($unlocks['night_owl'])) {
              ?>
              <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/night_owl_on.png" alt="Night Owl"/>
            <?php } else { ?>
              <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/night_owl_off.png" alt="Night Owl"/>
            <?php } ?>
            <strong>Night Owl</strong>
          </li>
          <li>
            <?php
            if (!empty($unlocks) && !empty($unlocks['hyperspeed'])) {
              ?>
              <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/hyperspeed_on.png" alt="HyperSpeed"/>
            <?php } else { ?>
              <img src="<?php echo WPS_IC_URI; ?>/assets/unlocks/hyperspeed_off.png" alt="HyperSpeed"/>
            <?php } ?>
            <strong>HyperSpeed</strong>
          </li>
        </ul>
        <div class="wp-ic-header-cta">
          <a href="https://wpcompress.com/faq/" class="wp-ic-button button-round">FAQ</a>
        </div>
      </div>
      <div class="clearfix"></div>
    </div>

    <?php

    #echo 'Woo you saved!';
    #var_dump($wps_ic->stats->get());

    if (empty($response_key) || ! $response_key) {
      ?>

      <?php
      if (empty($_GET['do'])) {
        ?>
        <div class="wp-compress-subheader">
          <h4>Create an account to receive access to WP Compress</h4>
        </div>
        <?php
      } else { ?>
        <div class="wp-compress-subheader">
          <h4>Enter your API Key to connect to the Compression Cloud</h4>
        </div>
      <?php } ?>


      <div class="wps_ic_form_centered">

        <?php if (empty($_GET['do'])) { ?>
          <form method="post" action="<?php echo admin_url('admin.php?page=wps_ic&do=signup'); ?>" id="wps_ic_signup_form">
            <div class="wps_ic_singup_form slideInUp animated">
              <div class="wps_ic_form_header">
                <h3>Account Information</h3>
              </div>
              <div class="wps_ic_form_input">
                <label>Name</label>
                <input type="text" name="name" placeholder="John Doe"/>
              </div>
              <div class="wps_ic_form_input">
                <label>E-Mail</label>
                <input type="text" name="email" placeholder="john@johndoe.com"/>
              </div>
              <div class="wps_ic_form_input pull_right">
                <input type="submit" name="submit" value="Sign Up"/>
              </div>
            </div>
          </form>
        <?php } else { ?>
          <form method="post" action="<?php echo admin_url('admin.php?page=wps_ic&do=activate'); ?>" id="wps_ic_activate_form">
            <div class="wps_ic_activate_form slideInUp animated">
              <div class="wps_ic_form_header">
                <h3>Activate</h3>
              </div>
              <div class="wps_ic_form_input">
                <label>API Key</label>
                <input type="text" name="apikey" placeholder="f7bebe2a9a123456789a3b0b2ac4633a700e4101"/>
              </div>
              <div class="wps_ic_form_input pull_right">
                <input type="submit" name="submit" value="Activate"/>
              </div>
            </div>
          </form>
        <?php } ?>

        <div class="wps-ic-form-loading-container" style="display:none;">
          <div class="wps-ic-form-loading"><img src="<?php echo WPS_IC_URI; ?>assets/images/spinner.svg"/></div>
        </div>


        <div class="wps-ic-form-success-container" style="display:none;">
          <div class="wps-ic-form-subscribe" style="display: none;">
            <img src="<?php echo WPS_IC_URI; ?>assets/images/api_success.png" alt="Success"/>
            <h3>We have sent confirmation e-mail to your address.</h3>
          </div>

          <div class="wps-ic-form-connect" style="display: none;">
            <img src="<?php echo WPS_IC_URI; ?>assets/images/api_success.png" alt="Success"/>
            <h3>We have successfully connected with cloud!</h3>
          </div>

          <div class="wps-ic-form-error" style="display: none;">
            <img src="<?php echo WPS_IC_URI; ?>assets/images/api_error.png" alt="Error"/>
            <h3></h3>
            <p>Form will reappear in 5 seconds.</p>
          </div>
        </div>

        <div class="wps_ic_form_other_option">
          <?php
          if (empty($_GET['do'])) {
            ?>
            <a href="<?php echo admin_url('admin.php?page=wps_ic&do=have_api_key'); ?>" class="fadeIn">Already have an API Key?</a>
          <?php } else { ?>
            <a href="<?php echo admin_url('admin.php?page=wps_ic'); ?>" class="fadeIn noline">Don't have an API Key</a>
            <strong style="">OR</strong>
            <a href="https://www.wpcompress.com/lost-api-key/" target="_blank" class="fadeIn noline">Forgot your API Key?</a>
          <?php } ?>
        </div>

      </div>

    <?php } else { ?>
      <form method="post" action="<?php echo admin_url('admin.php?page=wps_ic'); ?>">

        <?php
        if ( ! empty($_POST)) {
          ?>
          <div class="wp-compress-footer-success-msg wps-ic-hide" data-after="3">
            <table class="form-table">
              <tbody>
              <tr>
                <td colspan="2">

                  <h3>Changes saved!</h3>

                </td>
              </tr>
              </tbody>
            </table>
          </div>
          <?php
        }
        ?>

        <?php
        $license = 'Personal License';
        if ($orp) {
          $license = 'Professional';
          $credits = 'Unlimited';
        }
        ?>

        <div class="wp-compress-subheader">

              <div class="td-third">
                <strong>Account Type: <?php echo $license; ?></strong>
              </div>
              <div class="td-third td-center" class="wp-ic-saved-details">
                <?php
                if ( ! empty($response_key)) {
                  if (empty($stats[0]->sum_saved)) {
                    ?>
                    <h3>You haven't compressed any images!</h3>
                    <strong class="credits-line"><?php echo $credits; ?> Image Credits Available</strong>
                    <?php
                  } else {
                    $count = $stats[0]->count;
                    if ($count > 1) {
                      $count .= ' images';
                    } else {
                      $count .= ' image';
                    }
                    ?>
                    <h3>You've saved <?php echo size_format($stats[0]->sum_saved, 2); ?> using WP Compress</h3>
                    <strong class="credits-line">
                      <?php echo $credits; ?> Image Credits Available
                      <?php if ($orp) {?>
                        <?php
                        $quota = $ajax->wps_ic_api_quota();
                        echo ' - ' . $quota->count . '/' . $quota->allowed . ' Sites Used';
                        ?>
                      <?php } ?>
                    </strong>
                  <?php }
                }
                ?>
              </div>
              <div class="td-third td-right td-last">
                <div class="wp-ic-referrals">
                  <h3>
                    <?php echo $referrals->total_referrals; ?>
                  </h3>
                  <strong>Referrals</strong>
                </div>
                <div>
                  <strong>Your referral link is:</strong>
                  <a href="https://WPCompress.com/?ref=<?php echo $referrals->refID; ?>">https://WPCompress.com/?ref=<?php echo $referrals->refID; ?></a>
                </div>
              </div>
        </div>

        <div class="wps_ic_wrap_inner">
          <table class="form-table">
            <tbody>

            <tr>
              <th>
                Initialization tests
                <p class="desc">We need to verify your server is set up properly to use WP Compress.</p>
              </th>
              <td>
                <?php
                $tests = new wps_ic_tests();
                $tests->run();
                ?>
              </td>
            </tr>
            <?php
            $save_settings = $wps_ic->options->save_settings();
            $settings      = $wps_ic->options->get_settings();
            $response_key  = $wps_ic->options->get_option('response_key');

            // Get current active setting
            $wps_ic_active_settings['optimization']['normal']   = '';
            $wps_ic_active_settings['optimization']['maximum']  = '';
            $wps_ic_active_settings['optimization']['advanced'] = '';
            $wps_ic_active_settings['optimization']['ultra']    = '';

            if ($settings['optimization'] == 'normal') {
              $wps_ic_active_settings['optimization']['normal'] = 'class="current"';
            } else if ($settings['optimization'] == 'maximum') {
              $wps_ic_active_settings['optimization']['maximum'] = 'class="current"';
            } else if ($settings['optimization'] == 'advanced') {
              $wps_ic_active_settings['optimization']['advanced'] = 'class="current"';
            } else {
              $wps_ic_active_settings['optimization']['ultra'] = 'class="current"';
            }

            if (empty($settings['resize_larger_images_width'])) {
              $settings['resize_larger_images_width'] = '2048';
            }

            if (empty($settings['preserve_exif'])) {
              $settings['preserve_exif'] = '0';
            }

            if (empty($settings['debug'])) {
              $settings['debug'] = '0';
            }

            if (empty($settings['backup'])) {
              $settings['backup'] = '0';
            }

            if (empty($settings['resize_larger_images'])) {
              $settings['resize_larger_images'] = '0';
            }

            if (empty($response_key)) {
              ?>
              <tr>
                <th>
                  Authorize with API
                  <p class="desc">Yeah, just click the button! Simple as that! :)</p>
                </th>
                <td>
                  <a href="<?php echo admin_url('admin.php?page=wps_ic'); ?>" class="button button-primary wps-ic-authorize-api <?php if ( ! empty($_GET['trigger_connect'])) {
                    echo 'wps-ic-trigger_connect';
                  } ?>">Authorize</a>
                </td>
              </tr>
            <?php } else { ?>
              <tr>
                <th>
                  Disconnect from Compression Cloud
                  <p class="desc">Leaving us? :( <strong>By deauthorizing the API you will no longer be able to optimize additional images!</strong></p>
                </th>
                <td>
                  <a href="#" class="button button-secondary wps-ic-deauthorize-api">Deauthorize</a>
                </td>
              </tr>
            <?php } ?>
            <tr data-intro="Select prefered compression method.">
              <th>
                Optimization Level
                <p class="desc">When moving up the scale from Lossless towards Ultra, you trade image quality for smaller file size. If you are unsure, we recommend using intelligent.</p>
              </th>
              <td>
                <div class="wp-ic-select-box">
                  <input type="hidden" name="wp-ic-setting[optimization]" id="wp-ic-setting-optimization" value="<?php echo $settings['optimization']; ?>"/>
                  <ul>
                    <li <?php echo $wps_ic_active_settings['optimization']['normal']; ?>><a href="#" class="wps-ic-change-optimization" data-optimization_level="normal">Lossless</a></li>
                    <li <?php echo $wps_ic_active_settings['optimization']['maximum']; ?>><a href="#" class="wps-ic-change-optimization" data-optimization_level="maximum">Intelligent</a></li>
                    <li <?php echo $wps_ic_active_settings['optimization']['ultra']; ?>><a href="#" class="wps-ic-change-optimization" data-optimization_level="ultra">Ultra</a></li>
                  </ul>
                </div>
              </td>
            </tr>
            <tr data-intro="Do you want WP Compress to resize your images?">
              <th>
                Resize Larger Images:
                <p class="desc">Resizes images if they are larger than the set maximum width. We recommend 2048px for standard use cases or 1024px when optimizing non-critical images for speed.</p>
              </th>
              <td>
                <div class="toggle-container">
                  <input type="checkbox" name="wp-ic-setting[resize_larger_images]" id="wp-ic-setting-resize_larger_images" class="ios-toggle wps-ic-change-setting" data-setting_name="resize_larger_images"
                         data-setting_value="1" <?php echo checked('1', $settings['resize_larger_images']); ?> value="1"/>
                  <label for="wp-ic-setting-resize_larger_images" class="checkbox-label"></label>
                </div>
                <div class="wp-ic-toggle-addition">
                  to maximum <input type="text" name="wp-ic-setting[resize_larger_images_width]" value="<?php echo $settings['resize_larger_images_width']; ?>" placeholder="1024"/> pixels width.
                </div>
              </td>
            </tr>
            <tr data-intro="Backup of images is strongly suggested, but it will take up some extra space.">
              <th>
                Backup Original Images
                <p class="desc">Not satisfied with the settings you’ve chosen? Leave this option toggled and we’ll backup your original images to allow you to restore at any time.</p>
              </th>
              <td>
                <div class="toggle-container">
                  <input type="checkbox" name="wp-ic-setting[backup]" id="wp-ic-setting-backup" class="ios-toggle wps-ic-change-setting" data-setting_name="backup" data-setting_value="1" <?php echo checked('1', $settings['backup']); ?> value="1"/>
                  <label for="wp-ic-setting-backup" class="checkbox-label"></label>
                </div>
              </td>
            </tr>
            <tr data-intro="Debug for developers or geeks :)">
              <th>
                Debugging:
                <p class="desc">Enabled or disable <a href="<?php echo admin_url('admin.php?page=wps_ic&view_debug_log=true'); ?>" target="_blank">debug log</a>.</p>
                <p class="desc"><a href="<?php echo admin_url('admin.php?page=wps_ic&reset_debug_log=true'); ?>">Reset</a></p>
              </th>
              <td>
                <div class="toggle-container">
                  <input type="checkbox" name="wp-ic-setting[debug]" id="wp-ic-setting-debug" class="ios-toggle wps-ic-change-setting" data-setting_name="debug" data-setting_value="1" <?php echo checked('1', $settings['debug']); ?> value="1"/>
                  <label for="wp-ic-setting-debug" class="checkbox-label"></label>
                </div>
              </td>
            </tr>
            <tr data-intro="Is this a photography site? Then you should probably save your EXIF!">
              <th>
                Preserve EXIF Data
                <p class="desc">An advanced feature for photographers. If you’re unsure of what this means it’s best to leave it off.</p>
              </th>
              <td>
                <div class="toggle-container">
                  <input type="checkbox" name="wp-ic-setting[preserve_exif]" id="wp-ic-setting-preserve_exif" class="ios-toggle wps-ic-change-setting" data-setting_name="preserve_exif" data-setting_value="1" <?php echo checked('1',
                                                                                                                                                                                                                                   $settings['preserve_exif']); ?>
                         value="1"/>
                  <label for="wp-ic-setting-preserve_exif" class="checkbox-label"></label>
                </div>
              </td>
            </tr>


            <?php do_action('wps_no_settings'); ?>

            </tbody>
          </table>
        </div>

        <div class="wp-compress-footer">
          <table class="form-table">
            <tbody>
            <tr>
              <td colspan="2">
                <input type="submit" name="submit" class="button button-primary" value="Save Changes"/>
              </td>
            </tr>
            </tbody>
          </table>
        </div>

      </form>
    <?php } ?>


  </div>
</div>