
<!--
    <div class="wp-compress-subheader wp-ic-rating">
      <strong>Do you love WP Compress?</strong>
      <p>Please take a few seconds to <a href="#">show your love by rating it</a>!</p>
    </div>-->


    <form method="post" action="<?php echo admin_url('admin.php?page=wps_ic'); ?>">

      <div class="wp-compress-footer">
        <table class="form-table">
          <tbody>
          <tr>
            <td colspan="2">
              <input type="submit" name="submit" class="button button-primary" value="Save Changes"/>
            </td>
          </tr>
          </tbody>
        </table>
      </div>

      <div class="wps_ic_wrap_inner">
        <table class="form-table">
          <tbody>

          <tr>
            <th>
              Initialization tests
              <p class="desc">We need to verify your server is set up properly to use WP Compress.</p>
            </th>
            <td>
              <?php
              $tests = new wps_ic_tests();
              $tests->run();
              ?>
            </td>
          </tr>

		  <?php
		  $save_settings = $wps_ic->options->save_settings();
		  $settings      = $wps_ic->options->get_settings();
		  $response_key  = $wps_ic->options->get_option('response_key');
		  
		  // Get current active setting
		  $wps_ic_active_settings['optimization']['normal']   = '';
		  $wps_ic_active_settings['optimization']['maximum']  = '';
		  $wps_ic_active_settings['optimization']['advanced'] = '';
		  $wps_ic_active_settings['optimization']['ultra']    = '';
		  
		  if ($settings['optimization'] == 'normal') {
			  $wps_ic_active_settings['optimization']['normal'] = 'class="current"';
		  } else if ($settings['optimization'] == 'maximum') {
			  $wps_ic_active_settings['optimization']['maximum'] = 'class="current"';
		  } else if ($settings['optimization'] == 'advanced') {
			  $wps_ic_active_settings['optimization']['advanced'] = 'class="current"';
		  } else {
			  $wps_ic_active_settings['optimization']['ultra'] = 'class="current"';
		  }
		  
		  if (empty($settings['resize_larger_images_width'])) {
			  $settings['resize_larger_images_width'] = '2048';
		  }
		  
		  if (empty($response_key)) {
			  ?>
            <tr>
              <th>
                Authorize with API
                <p class="desc">Yeah, just click the button! Simple as that! :)</p>
              </th>
              <td>
                <a href="<?php echo admin_url('admin.php?page=wps_ic'); ?>" class="button button-primary wps-ic-authorize-api <?php if (!empty($_GET['trigger_connect'])) {
					echo 'wps-ic-trigger_connect';
				} ?>">Authorize</a>
              </td>
            </tr>
		  <?php } else { ?>
            <tr>
              <th>
                Deauthorize with API
                <p class="desc">Leaving us? :( <strong>By deauthorizing with our API you will lose compress options!</strong></p>
              </th>
              <td>
                <a href="#" class="button button-secondary wps-ic-deauthorize-api">Deauthorize</a>
              </td>
            </tr>
		  <?php } ?>
          <tr>
            <th>
              Optimization Level
              <p class="desc">Quality of the optimized image and resulting file size. Lossless provides the highest quality, while Ultra provides smallest compressed file size.</p>
            </th>
            <td>
              <div class="wp-ic-select-box">
                <input type="hidden" name="wp-ic-setting[optimization]" id="wp-ic-setting-optimization" value="<?php echo $settings['optimization']; ?>"/>
                <ul>
                  <li <?php echo $wps_ic_active_settings['optimization']['normal']; ?>><a href="#" class="wps-ic-change-optimization" data-optimization_level="normal">Lossless</a></li>
                  <li <?php echo $wps_ic_active_settings['optimization']['maximum']; ?>><a href="#" class="wps-ic-change-optimization" data-optimization_level="maximum">Intelligent</a></li>
                  <li <?php echo $wps_ic_active_settings['optimization']['ultra']; ?>><a href="#" class="wps-ic-change-optimization" data-optimization_level="ultra">Ultra</a></li>
                </ul>
              </div>
            </td>
          </tr>
          <tr>
            <th>
              Resize Larger Images:
              <p class="desc">Resizes images if they are larger than the set maximum width. We recommend 2048px if optimizing for quality and 1024px if optimizing for file size.</p>
            </th>
            <td>
              <div class="toggle-container">
                <input type="checkbox" name="wp-ic-setting[resize_larger_images]" id="wp-ic-setting-resize_larger_images" class="ios-toggle wps-ic-change-setting" data-setting_name="resize_larger_images" data-setting_value="1" <?php echo checked('1', $settings['resize_larger_images']); ?> value="1"/>
                <label for="wp-ic-setting-resize_larger_images" class="checkbox-label"></label>
              </div>
              <div class="wp-ic-toggle-addition">
                to maximum <input type="text" name="wp-ic-setting[resize_larger_images_width]" value="<?php echo $settings['resize_larger_images_width']; ?>" placeholder="1024"/> pixels width.
              </div>
            </td>
          </tr>
          <tr>
            <th>
              Backup Original Images
              <p class="desc">We backup your original images and allow you to restore as needed.</p>
            </th>
            <td>
              <div class="toggle-container">
                <input type="checkbox" name="wp-ic-setting[backup]" id="wp-ic-setting-backup" class="ios-toggle wps-ic-change-setting" data-setting_name="backup" data-setting_value="1" <?php echo checked('1', $settings['backup']); ?> value="1"/>
                <label for="wp-ic-setting-backup" class="checkbox-label"></label>
              </div>
            </td>
          </tr>
          <tr>
            <th>
              Debugging:
              <p class="desc">Enabled or disable <a href="<?php echo WPS_IC_URI . 'log.txt'; ?>">debug log</a>.</p>
            </th>
            <td>
              <div class="toggle-container">
                <input type="checkbox" name="wp-ic-setting[debug]" id="wp-ic-setting-debug" class="ios-toggle wps-ic-change-setting" data-setting_name="debug" data-setting_value="1" <?php echo checked('1', $settings['debug']); ?> value="1"/>
                <label for="wp-ic-setting-debug" class="checkbox-label"></label>
              </div>
            </td>
          </tr>
      <tr>
        <th>
          Preserve EXIF Data
          <p class="desc">For photographers needing additional data on their images. IF you are unsure on what this means it is best to leave it off.</p>
        </th>
        <td>
          <div class="toggle-container">
            <input type="checkbox" name="wp-ic-setting[preserve_exif]" id="wp-ic-setting-preserve_exif" class="ios-toggle wps-ic-change-setting" data-setting_name="preserve_exif" data-setting_value="1" <?php echo checked('1', $settings['preserve_exif']); ?> value="1"/>
            <label for="wp-ic-setting-preserve_exif" class="checkbox-label"></label>
          </div>
        </td>
      </tr>
      <!--
          <tr class="wps-ic-pro-features">
            <td colspan="2">
              Pro Features
            </td>
          </tr>-->
		  
		  <?php #do_action('wps_ic_pro_features'); ?>

          </tbody>
        </table>
      </div>

      <div class="wp-compress-footer">
        <table class="form-table">
          <tbody>
          <tr>
            <td colspan="2">
              <input type="submit" name="submit" class="button button-primary" value="Save Changes"/>
            </td>
          </tr>
          </tbody>
        </table>
      </div>

    </form>
